
(in-package :traps)             ; 
; Created: Thursday, October 4, 1990 at 8:00 AM
; 	ENET.p
; 	Pascal Interface to the Macintosh Libraries
; 
; 	Copyright Apple Computer, Inc. 1989-1990
; 	All rights reserved
; 

;;;;;;;;;;;;;
;
; Modification History
;
; 04/28/93 mwp Release
; 08/10/92 bill thepbptr -> pb in all traps

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingENET
; $SETC UsingENET := 1

; $I+
; $SETC ENETIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingTypes

(require-interface 'TYPES)      ; $I $$Shell(PInterfaces)Types.p
; $ENDC
; $IFC UNDEFINED UsingOSUtils

(require-interface 'OSUTILS)    ; $I $$Shell(PInterfaces)OSUtils.p
; $ENDC
; $SETC UsingIncludes := ENETIncludes

(defconstant $ENetSetGeneral 253); Set "general" mode
(defconstant $ENetGetInfo 252)  ; Get info
(defconstant $ENetRdCancel 251) ; Cancel read
(defconstant $ENetRead 250)     ; Read
(defconstant $ENetWrite 249)    ; Write
(defconstant $ENetDetachPH 248) ; Detach protocol handler
(defconstant $ENetAttachPH 247) ; Attach protocol handler
(defconstant $ENetAddMulti 246) ; Add a multicast address
(defconstant $ENetDelMulti 245) ; Delete a multicast address

(defconstant $eLenErr -92)      ; Length error ddpLenErr
(defconstant $eMultiErr -91)    ; Multicast address error ddpSktErr

(defconstant $EAddrRType :|eadr|); Alternate address resource type

(def-mactype :eparamblkptr (find-mactype :pointer))
(defrecord EParamBlock 
   (qLink (:pointer :qelem))    ; next queue entry
   (qType :signed-integer)      ; queue type
   (ioTrap :signed-integer)     ; routine trap
   (ioCmdAddr :pointer)         ; routine address
   (ioCompletion :pointer)      ; completion routine
   (ioResult :signed-integer)   ; result code
   (ioNamePtr (:pointer (:string 255))); ->filename
   (ioVRefNum :signed-integer)  ; volume reference or drive number
   (ioRefNum :signed-integer)   ; driver reference number
   (csCode :signed-integer)     ; call command code AUTOMATICALLY set
   (:variant 

      ((eProtType :signed-integer); Ethernet protocol type
      (ePointer :pointer)
      (eBuffSize :signed-integer); buffer size
      (eDataSize :signed-integer)); number of bytes read

      ((eMultiAddr (:array :character 6))); Multicast Address
      ))



(deftrap _ewrite ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 249) pb)))

(deftrap _eattachph ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 247) pb)))

(deftrap _edetachph ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 248) pb)))

(deftrap _eread ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 250) pb)))

(deftrap _erdcancel ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 251) pb)))

(deftrap _egetinfo ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 252) pb)))

(deftrap _esetgeneral ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 253) pb)))

(deftrap _eaddmulti ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 246) pb)))

(deftrap _edelmulti ((pb (:pointer :eparamblock)) (async :boolean))
   (:d0 :signed-integer)
   (:register-trap #xA004 :a0 (progn (setf (ccl:rref pb :eparamblock.cscode) 245) pb)))
; $ENDC


(export '($eaddrrtype $emultierr $elenerr $enetdelmulti $enetaddmulti
          $enetattachph $enetdetachph $enetwrite $enetread $enetrdcancel
          $enetgetinfo $enetsetgeneral))
(provide-interface 'ENET)