
(in-package :traps)             ; 
; Created: Friday, January 25, 1991 at 11:34 AM
;     Packages.p
;     Pascal Interface to the Macintosh Libraries
; 
;         Copyright Apple Computer, Inc.    1985-1990
;         All rights reserved
; 

;;;;;;;;;;;;;
;
; Modification History
;
; 04/28/93 mwp Release
; 08/10/92 bill typo in _NumtoString
; ------------- 2.0
; 02/18/92 bill _IUStringOrder is not in rom.
; ------------- 2.0f2
; 08/29/91 bill get rid of :invalid-type
; 08/23/91 bill Missing :NO-TRAP in _IUEqualPString
;

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingPackages
; $SETC UsingPackages := 1

; $I+
; $SETC PackagesIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingTypes

(require-interface 'TYPES)      ; $I $$Shell(PInterfaces)Types.p
; $ENDC
; $IFC UNDEFINED UsingStandardFile

(require-interface 'STANDARDFILE); $I $$Shell(PInterfaces)StandardFile.p
; $ENDC
; $IFC UNDEFINED UsingScript

(require-interface 'SCRIPT)     ; $I $$Shell(PInterfaces)Script.p
; $ENDC
; $SETC UsingIncludes := PackagesIncludes

(defconstant $listMgr 0)        ; list manager
(defconstant $dskInit 2)        ; Disk Initializaton
(defconstant $stdFile 3)        ; Standard File
(defconstant $flPoint 4)        ; Floating-Point Arithmetic
(defconstant $trFunc 5)         ; Transcendental Functions
(defconstant $intUtil 6)        ; International Utilities
(defconstant $bdConv 7)         ; Binary/Decimal Conversion
(defconstant $editionMgr 11)    ; Edition Manager
(defconstant $currSymLead 16)
(defconstant $currNegSym 32)
(defconstant $currTrailingZ 64)
(defconstant $currLeadingZ 128)
(defconstant $zeroCycle 1)      ; 0:00 AM/PM format
(defconstant $longDay 0)        ; day of the month
(defconstant $longWeek 1)       ; day of the week
(defconstant $longMonth 2)      ; month of the year
(defconstant $longYear 3)       ; year
(defconstant $supDay 1)         ; suppress day of month
(defconstant $supWeek 2)        ; suppress day of week
(defconstant $supMonth 4)       ; suppress month
(defconstant $supYear 8)        ; suppress year
(defconstant $dayLdingZ 32)
(defconstant $mntLdingZ 64)
(defconstant $century 128)
(defconstant $secLeadingZ 32)
(defconstant $minLeadingZ 64)
(defconstant $hrLeadingZ 128)

;  Date Orders 
(defconstant $mdy 0)
(defconstant $dmy 1)
(defconstant $ymd 2)
(defconstant $myd 3)
(defconstant $dym 4)
(defconstant $ydm 5)

(defconstant $verUS 0)
(defconstant $verFrance 1)
(defconstant $verBritain 2)
(defconstant $verGermany 3)
(defconstant $verItaly 4)
(defconstant $verNetherlands 5)
(defconstant $verFrBelgiumLux 6);  French for Belgium & Luxembourg 
(defconstant $verSweden 7)
(defconstant $verSpain 8)
(defconstant $verDenmark 9)
(defconstant $verPortugal 10)
(defconstant $verFrCanada 11)
(defconstant $verNorway 12)
(defconstant $verIsrael 13)
(defconstant $verJapan 14)
(defconstant $verAustralia 15)
(defconstant $verArabic 16)     ;  synonym for verArabia 
(defconstant $verFinland 17)
(defconstant $verFrSwiss 18)    ;  French Swiss 
(defconstant $verGrSwiss 19)    ;  German Swiss 
(defconstant $verGreece 20)
(defconstant $verIceland 21)
(defconstant $verMalta 22)
(defconstant $verCyprus 23)
(defconstant $verTurkey 24)
(defconstant $verYugoCroatian 25);  Croatian system for Yugoslavia 
(defconstant $verIndiaHindi 33) ;  Hindi system for India 
(defconstant $verPakistan 34)
(defconstant $verLithuania 41)
(defconstant $verPoland 42)
(defconstant $verHungary 43)
(defconstant $verEstonia 44)
(defconstant $verLatvia 45)
(defconstant $verLapland 46)
(defconstant $verFaeroeIsl 47)
(defconstant $verIran 48)
(defconstant $verRussia 49)
(defconstant $verIreland 50)    ;  English-language version for Ireland 
(defconstant $verKorea 51)
(defconstant $verChina 52)
(defconstant $verTaiwan 53)
(defconstant $verThailand 54)
(defconstant $minCountry #$verus)
(defconstant $maxCountry #$verthailand)

; Obsolete region code names, kept for backward compatibility
(defconstant $verBelgiumLux 6)  ; (use verFrBelgiumLux instead, less ambiguous)
(defconstant $verArabia 16)
(defconstant $verYugoslavia 25) ; (use verYugoCroatian instead, less ambiguous)
(defconstant $verIndia 33)      ; (use verIndiaHindi instead, less ambiguous) 

; special ScriptCode values
(defconstant $iuSystemScript -1);  system script 
(defconstant $iuCurrentScript -2);  current script 

; special LangCode values
(defconstant $iuSystemCurLang -2);  current (itlbLang) lang for system script 
(defconstant $iuSystemDefLang -3);  default (table) lang for system script 
(defconstant $iuCurrentCurLang -4);  current (itlbLang) lang for current script 
(defconstant $iuCurrentDefLang -5);  default lang for current script 
(defconstant $iuScriptCurLang -6);  current (itlbLang) lang for specified script 
(defconstant $iuScriptDefLang -7);  default language for a specified script 

; table selectors for IUGetItlTable
(defconstant $iuWordSelectTable 0)
(defconstant $iuWordWrapTable 1)
(defconstant $iuNumberPartsTable 2)
(defconstant $iuUnTokenTable 3)
(defconstant $iuWhiteSpaceList 4)

(def-mactype :dateform (find-mactype :unsigned-byte))
(defconstant $shortDate 0)
(defconstant $longDate 1)
(defconstant $abbrevDate 2)

(def-mactype :intl0ptr (find-mactype :pointer))
(def-mactype :intl0hndl (find-mactype :handle))
(defrecord (Intl0Rec :handle) 
   (decimalPt :character)       ; decimal point character
   (thousSep :character)        ; thousands separator
   (listSep :character)         ; list separator
   (currSym1 :character)        ; currency symbol
   (currSym2 :character)
   (currSym3 :character)
   (currFmt :unsigned-byte)     ; currency format
   (dateOrder :unsigned-byte)   ; order of short date elements
   (shrtDateFmt :unsigned-byte) ; short date format
   (dateSep :character)         ; date separator
   (timeCycle :unsigned-byte)   ; 0 if 24-hour cycle, 255 if 12-hour
   (timeFmt :unsigned-byte)     ; time format
   (mornStr :ostype)            ; trailing string for first 12-hour cycle
   (eveStr :ostype)             ; trailing string for last 12-hour cycle
   (timeSep :character)         ; time separator
   (time1Suff :character)       ; trailing string for 24-hour cycle
   (time2Suff :character)
   (time3Suff :character)
   (time4Suff :character)
   (time5Suff :character)
   (time6Suff :character)
   (time7Suff :character)
   (time8Suff :character)
   (metricSys :unsigned-byte)   ; 255 if metric, 0 if not
   (intl0Vers :signed-integer)  ; version information
   )

(def-mactype :intl1ptr (find-mactype :pointer))
(def-mactype :intl1hndl (find-mactype :handle))
(defrecord (Intl1Rec :handle) 
   (days (:array (:string 15) 7)); day names
   (months (:array (:string 15) 12)); month names
   (suppressDay :unsigned-byte) ; 0 for day name, 255 for none
   (lngDateFmt :unsigned-byte)  ; order of long date elements
   (dayLeading0 :unsigned-byte) ; 255 for leading 0 in day number
   (abbrLen :unsigned-byte)     ; length for abbreviating names
   (st0 :ostype)                ; strings for long date format
   (st1 :ostype)
   (st2 :ostype)
   (st3 :ostype)
   (st4 :ostype)
   (intl1Vers :signed-integer)  ; version information
   (localRtn (:array :signed-integer 1)); routine for localizing string comparison
   )


(deftrap _initpack ((packid :signed-integer))
   nil
   (:stack-trap #xA9E5))

(deftrap _initallpacks nil
   nil
   (:stack-trap #xA9E6))


(deftrap _iugetintl ((theid :signed-integer))
   (:stack :handle)
   (:stack-trap #xA9ED theid (6 :signed-integer)))

(deftrap _iusetintl ((refnum :signed-integer) (theid :signed-integer) (intlhandle :handle))
   nil
   (:stack-trap #xA9ED refnum theid intlhandle (8 :signed-integer)))

(deftrap _iudatestring ((datetime :signed-long) (longflag :unsigned-byte) (result (:pointer (:string 255))))
   nil
   (:stack-trap #xA9ED datetime longflag result (0 :signed-integer)))

(deftrap _iudatepstring ((datetime :signed-long) (longflag :unsigned-byte) (result (:pointer (:string 255))) (intlhandle :handle))
   nil
   (:stack-trap #xA9ED datetime longflag result intlhandle (14 :signed-integer)))

(deftrap _iutimestring ((datetime :signed-long) (wantseconds :boolean) (result (:pointer (:string 255))))
   nil
   (:stack-trap #xA9ED datetime wantseconds result (2 :signed-integer)))

(deftrap _iutimepstring ((datetime :signed-long) (wantseconds :boolean) (result (:pointer (:string 255))) (intlhandle :handle))
   nil
   (:stack-trap #xA9ED datetime wantseconds result intlhandle (16 :signed-integer)))

(deftrap _iumetric nil
   (:stack :boolean)
   (:stack-trap #xA9ED (4 :signed-integer)))


(deftrap _iumagstring ((aptr :pointer) (bptr :pointer) (alen :signed-integer) (blen :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aptr bptr alen blen (10 :signed-integer)))

(deftrap _iumagidstring ((aptr :pointer) (bptr :pointer) (alen :signed-integer) (blen :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aptr bptr alen blen (12 :signed-integer)))

(deftrap _iucompstring ((astr (:string 255)) (bstr (:string 255)))
   (:no-trap :signed-integer)
   (:no-trap (gopmag 10 astr bstr)))

(deftrap _iuequalstring ((astr (:string 255)) (bstr (:string 255)))
   (:no-trap :signed-integer)
   (:no-trap (gopmag 12 astr bstr)))

(deftrap _stringtonum ((thestring (:string 255)) (thenum (:pointer :signed-long)))
   nil
   (:no-trap (%put-long thenum (ccl::%gen-trap #xA9EE :a0 thestring :word 1 :d0))))

(deftrap _numtostring ((thenum :signed-long) (thestring (:pointer (:string 255))))
   nil
   (:no-trap (ccl::%gen-trap #xA9EE :d0 thenum :a0 thestring :word 0)))

(deftrap _iuldatestring ((datetime (:pointer :longdatetime)) (longflag :unsigned-byte) (result (:pointer (:string 255))) (intlhandle :handle))
   nil
   (:stack-trap #xA9ED datetime longflag result intlhandle (20 :signed-integer)))

(deftrap _iultimestring ((datetime (:pointer :longdatetime)) (wantseconds :boolean) (result (:pointer (:string 255))) (intlhandle :handle))
   nil
   (:stack-trap #xA9ED datetime wantseconds result intlhandle (22 :signed-integer)))

(deftrap _iuclearcache nil
   nil
   (:stack-trap #xA9ED (24 :signed-integer)))

(deftrap _iumagpstring ((aptr :pointer) (bptr :pointer) (alen :signed-integer) (blen :signed-integer) (itl2handle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aptr bptr alen blen itl2handle (26 :signed-integer)))

(deftrap _iumagidpstring ((aptr :pointer) (bptr :pointer) (alen :signed-integer) (blen :signed-integer) (itl2handle :handle))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aptr bptr alen blen itl2handle (28 :signed-integer)))

(deftrap _iucomppstring ((astr (:string 255)) (bstr (:string 255)) (itl2handle :handle))
   (:no-trap :signed-integer)
   (:no-trap (gopmagp 26 astr bstr itl2handle)))

(deftrap _iuequalpstring ((astr (:string 255)) (bstr (:string 255)) (itl2handle :handle))
   (:no-trap :signed-integer)
  (:no-trap (gopmagp 28 astr bstr itl2handle)))

(deftrap _iuscriptorder ((script1 :signed-integer) (script2 :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED script1 script2 (30 :signed-integer)))

(deftrap _iulangorder ((language1 :signed-integer) (language2 :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED language1 language2 (32 :signed-integer)))

(deftrap _iutextorder ((aptr :pointer) (bptr :pointer) (alen :signed-integer) (blen :signed-integer) (ascript :signed-integer) (bscript :signed-integer) (alang :signed-integer) (blang :signed-integer))
   (:stack :signed-integer)
   (:stack-trap #xA9ED aptr bptr alen blen ascript bscript alang blang (34 :signed-integer)))

#|
(deftrap _iustringorder ((astr (:string 255)) (bstr (:string 255)) (ascript :signed-integer) (bscript :signed-integer) (alang :signed-integer) (blang :signed-integer))
  (:no-trap :signed-integer)
  (:no-trap (iustringorder pstr0 pstr0 ascript bscript alang blang)))
|#

(deftrap _iugetitltable ((script :signed-integer) (tablecode :signed-integer) (itlhandle (:pointer :handle)) (offset (:pointer :signed-long)) (length (:pointer :signed-long)))
   nil
   (:stack-trap #xA9ED script tablecode itlhandle offset length (36 :signed-integer)))

; $ENDC                         ;  UsingPackages 

; $IFC NOT UsingIncludes

; $ENDC


(export '($abbrevdate $longdate $shortdate $iuwhitespacelist $iuuntokentable
          $iunumberpartstable $iuwordwraptable $iuwordselecttable
          $iuscriptdeflang $iuscriptcurlang $iucurrentdeflang $iucurrentcurlang
          $iusystemdeflang $iusystemcurlang $iucurrentscript $iusystemscript
          $verindia $veryugoslavia $verarabia $verbelgiumlux $maxcountry
          $mincountry $verthailand $vertaiwan $verchina $verkorea $verireland
          $verrussia $veriran $verfaeroeisl $verlapland $verlatvia $verestonia
          $verhungary $verpoland $verlithuania $verpakistan $verindiahindi
          $veryugocroatian $verturkey $vercyprus $vermalta $vericeland
          $vergreece $vergrswiss $verfrswiss $verfinland $verarabic
          $veraustralia $verjapan $verisrael $vernorway $verfrcanada
          $verportugal $verdenmark $verspain $versweden $verfrbelgiumlux
          $vernetherlands $veritaly $vergermany $verbritain $verfrance $verus
          $ydm $dym $myd $ymd $dmy $mdy $hrleadingz $minleadingz $secleadingz
          $century $mntldingz $dayldingz $supyear $supmonth $supweek $supday
          $longyear $longmonth $longweek $longday $zerocycle $currleadingz
          $currtrailingz $currnegsym $currsymlead $editionmgr $bdconv $intutil
          $trfunc $flpoint $stdfile $dskinit $listmgr))
(provide-interface 'PACKAGES)
