
(in-package :TRAPS)
; 
; Created: Tuesday, August 13, 1991 at 4:31 PM
;  ImageCompression.p
;  Pascal Interface to the Macintosh Libraries
; 
;  Copyright Apple Computer, Inc. 1991
;  All rights reserved
; 

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingImageCompression
; $SETC UsingImageCompression := 1

; $I+
; $SETC ImageCompressionIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingQuickDraw

(require-interface 'QUICKDRAW)  ; $I $$Shell(PInterfaces)QuickDraw.p
; $ENDC
; $IFC UNDEFINED UsingQDOffscreen

(require-interface 'QDOFFSCREEN); $I $$Shell(PInterfaces)QDOffscreen.p
; $ENDC
; $IFC UNDEFINED UsingTypes

(require-interface 'TYPES)      ; $I $$Shell(PInterfaces)Types.p
; $ENDC
; $IFC UNDEFINED UsingComponents

(require-interface 'COMPONENTS) ; $I $$Shell(PInterfaces)Components.p
; $ENDC
; $IFC UNDEFINED UsingStandardFile

(require-interface 'STANDARDFILE); $I $$Shell(PInterfaces)StandardFile.p
; $ENDC
; $SETC UsingIncludes := ImageCompressionIncludes

(defconstant $gestaltCompressionMgr :|icmp|)

;  These are the bits that are set in the Component flags, and also in the codecInfo struct. 

(defconstant $codecInfoDoes1 #X1);  codec can work with 1-bit pixels 
(defconstant $codecInfoDoes2 #X2);  codec can work with 2-bit pixels 
(defconstant $codecInfoDoes4 #X4);  codec can work with 4-bit pixels 
(defconstant $codecInfoDoes8 #X8);  codec can work with 8-bit pixels 
(defconstant $codecInfoDoes16 #X10);  codec can work with 16-bit pixels 
(defconstant $codecInfoDoes32 #X20);  codec can work with 32-bit pixels 
(defconstant $codecInfoDoesDither #X40);  codec can do ditherMode 
(defconstant $codecInfoDoesStretch #X80);  codec can stretch to arbitrary sizes 
(defconstant $codecInfoDoesShrink #X100);  codec can shrink to arbitrary sizes 
(defconstant $codecInfoDoesMask #X200);  codec can mask to clipping regions 

(defconstant $codecInfoDoesTemporal #X400);  codec can handle temporal redundancy 

(defconstant $codecInfoDoesDouble #X800);  codec can stretch to double size exactly 
(defconstant $codecInfoDoesQuad #X1000);  codec can stretch to quadruple size exactly 
(defconstant $codecInfoDoesHalf #X2000);  codec can shrink to half size 
(defconstant $codecInfoDoesQuarter #X4000);  codec can shrink to quarter size 

(defconstant $codecInfoDoesRotate #X8000);  codec can rotate on decompress 
(defconstant $codecInfoDoesHorizFlip #X10000);  codec can flip horizontally on decompress 
(defconstant $codecInfoDoesVertFlip #X20000);  codec can flip vertically on decompress 
(defconstant $codecInfoDoesSkew #X40000);  codec can skew on decompress 
(defconstant $codecInfoDoesBlend #X80000);  codec can blend on decompress 
(defconstant $codecInfoDoesWarp #X100000);  codec can warp arbitrarily on decompress 
(defconstant $codecInfoDoesRecompress #X200000);  codec can recompress image without accumulating errors 
(defconstant $codecInfoDoesSpool #X400000);  codec can spool image data 

(defconstant $codecInfoDepth1 #X1);  compressed data at 1 bpp depth available 
(defconstant $codecInfoDepth2 #X2);  compressed data at 2 bpp depth available 
(defconstant $codecInfoDepth4 #X4);  compressed data at 4 bpp depth available 
(defconstant $codecInfoDepth8 #X8);  compressed data at 8 bpp depth available 
(defconstant $codecInfoDepth16 #X10);  compressed data at 16 bpp depth available 
(defconstant $codecInfoDepth32 #X20);  compressed data at 32 bpp depth available 
(defconstant $codecInfoDepth24 #X40);  compressed data at 24 bpp depth available 
(defconstant $codecInfoDepth33 #X80);  compressed data at 1 bpp monochrome depth  available 
(defconstant $codecInfoDepth34 #X100);  compressed data at 2 bpp grayscale depth available 
(defconstant $codecInfoDepth36 #X200);  compressed data at 4 bpp grayscale depth available 
(defconstant $codecInfoDepth40 #X400);  compressed data at 8 bpp grayscale depth available 
(defconstant $codecInfoStoresClut #X800);  compressed data can have custom cluts 
(defconstant $codecInfoDoesLossless #X1000);  compressed data can be stored in lossless format 

(defconstant $codecFlagUseImageBuffer #X1);  (input) allocate buffer for whole image on decompress sequence 
(defconstant $codecFlagUseScreenBuffer #X2);  (input) allocate buffer for screen on decompress sequence for faster updates 
(defconstant $codecFlagUpdatePrevious #X4);  (input) udate previous buffer on compress sequence 
(defconstant $codecFlagNoScreenUpdate #X8);  (input) dont update screen, but do update image buffer if allocated 
(defconstant $codecFlagWasCompressed #X10);  (input) hint to compressor that image was previously compressed 
(defconstant $codecFlagDontOffscreen #X20);  (input) return error instead of automatically going offscreen 
(defconstant $codecFlagUpdatePreviousComp #X40);  (input) udate previous buffer on compress sequence 
(defconstant $codecFlagForceKeyFrame #X80);  (input) when sent to CompressSequenceFrame, forces that frame to be a key frame 
(defconstant $codecFlagOnlyScreenUpdate #X100);  (input) only update screen from 
(defconstant $codecFlagLiveGrab #X200);  (input) data being compressed is from live source (speed is critical) 

(defconstant $codecFlagUsedNewImageBuffer #X4000);  (output) indicates that image buffer was first used on this decompress sequence 
(defconstant $codecFlagUsedImageBuffer #X8000);  (output) indicates that image buffer was used on this decompress sequence 

(defconstant $codecErr -8960)   ;  the codec returned an error 
(defconstant $noCodecErr -8961) ;  the specified codec could not be found 
(defconstant $codecUnimpErr -8962);  this feature is not implemented by the specified codec 
(defconstant $codecSizeErr -8963)
(defconstant $codecScreenBufErr -8964);  the screen buffer could not be allocated 
(defconstant $codecImageBufErr -8965);  the image buffer could not be allocated 
(defconstant $codecSpoolErr -8966);  the compressed data must be in memory (spooling did not work) 
(defconstant $codecAbortErr -8967);  the operation was aborted by the progress proc 
(defconstant $codecWouldOffscreenErr -8968);  an offscreen access would have been used, but wasn't allowed because codecFlagDontOffscreen was set 
(defconstant $codecBadDataErr -8969);  compressed data was found to have inconsistencies 
(defconstant $codecDataVersErr -8970);  compressed data was of a format version that codec couldn't handle 
(defconstant $codecConditionErr -8972);  codec can not do requested operation 
(defconstant $codecOpenErr -8973);  the codec  could not be opened 

(defconstant $codecMinimumDataSize 32768);  The minimum data size for spooling in or out data 

(defconstant $compressorComponentType :|imco|);  the type for "Components" which compress images 
(defconstant $decompressorComponentType :|imdc|);  the type for "Components" which decompress images 

(def-mactype :COMPRESSORCOMPONENT (find-mactype :POINTER));  a Component which compresses images 
(def-mactype :DECOMPRESSORCOMPONENT (find-mactype :POINTER));  a Component which decompresses images 
(def-mactype :CODECCOMPONENT (find-mactype :POINTER));  a Component which decompresses or compresses images 

(def-mactype :SBOOLEAN (find-mactype :SIGNED-INTEGER));  to make sure stack frames are right 

(def-mactype :CODECTYPE (find-mactype :OSTYPE));  type descriptor for codecs i.e: 'appl','jpeg','rle ' 

(def-mactype :CODECFLAGS (find-mactype :SIGNED-INTEGER));  flags for codec manager calls 

(def-mactype :CODECQ (find-mactype :SIGNED-LONG))
(def-mactype :DATAPROCPTR (find-mactype :POINTER))
(def-mactype :FLUSHPROCPTR (find-mactype :POINTER))

(defconstant $codecLosslessQuality #X400)
(defconstant $codecMaxQuality #X3FF)
(defconstant $codecMinQuality #X0)
(defconstant $codecLowQuality #X100)
(defconstant $codecNormalQuality #X200)
(defconstant $codecHighQuality #X300)

(defconstant $anyCodec 0)       ;  take first working codec of given type 
(defconstant $bestSpeedCodec -1);  take fastest codec of given type 
(defconstant $bestFidelityCodec -2);  take codec which is most accurate
(defconstant $bestCompressionCodec -3);  take codec of given type that is most accurate 

(defconstant $codecCompletionSource 1);  asynchronous codec is done with source data  
(defconstant $codecCompletionDest 2);  asynchronous codec is done with destination data  

(def-mactype :COMPLETIONPROCPTR (find-mactype :POINTER))

(defconstant $codecProgressOpen 0)
(defconstant $codecProgressUpdatePercent 1)
(defconstant $codecProgressClose 2)

(def-mactype :PROGRESSPROCPTR (find-mactype :POINTER))

(def-mactype :IMAGESEQUENCE (find-mactype :SIGNED-LONG))

(def-mactype :PROGRESSPROCRECORDPTR (find-mactype :POINTER))
(defrecord ProgressProcRecord 
   (progressProc :POINTER)
   (progressRefCon :SIGNED-LONG)
   )

(def-mactype :COMPLETIONPROCRECORDPTR (find-mactype :POINTER))
(defrecord CompletionProcRecord 
   (completionProc :POINTER)
   (completionRefCon :SIGNED-LONG)
   )

(def-mactype :DATAPROCRECORDPTR (find-mactype :POINTER))
(defrecord DataProcRecord 
   (dataProc :POINTER)
   (dataRefCon :SIGNED-LONG)
   )

(def-mactype :FLUSHPROCRECORDPTR (find-mactype :POINTER))
(defrecord FlushProcRecord 
   (flushProc :POINTER)
   (flushRefCon :SIGNED-LONG)
   )

;  
;     The ImageDescription is private data which is produced when an image or sequence 
;     is compressed. It fully describes the format of the compressed data.

(def-mactype :IMAGEDESCRIPTIONPTR (find-mactype :POINTER))
(def-mactype :IMAGEDESCRIPTIONHANDLE (find-mactype :HANDLE))
(defrecord (ImageDescription :handle) 
   (idSize :SIGNED-LONG)        ;  total size of ImageDescription including extra data ( CLUTs and other per sequence data 
   (cType :OSTYPE)              ;  what kind of codec compressed this data 
   (resvd1 :SIGNED-LONG)        ;  reserved for apple use 
   (resvd2 :SIGNED-INTEGER)     ;  reserved for apple use 
   (dataRefIndex :SIGNED-INTEGER);  set to zero 
   (version :SIGNED-INTEGER)    ;  which version is this data 
   (revisionLevel :SIGNED-INTEGER);  what version of that codec did this 
   (vendor :SIGNED-LONG)        ;  whose  codec compressed this data 
   (temporalQuality :SIGNED-LONG);  what was the temporal quality factor          
   (spatialQuality :SIGNED-LONG);  what was the spatial quality factor          
   (width :SIGNED-INTEGER)      ;  how many pixels wide is this data 
   (height :SIGNED-INTEGER)     ;  how many pixels high is this data 
   (hRes :SIGNED-LONG)          ;  horizontal resolution 
   (vRes :SIGNED-LONG)          ;  vertical resolution 
   (dataSize :SIGNED-LONG)      ;  if known, the size of data for this image descriptor 
   (frameCount :SIGNED-INTEGER) ;  number of frames this description applies to 
   (name (:ARRAY :CHARACTER 32));  name of codec ( in case not installed ) 
   (depth :SIGNED-INTEGER)      ;  what depth is this data (1-32) or ( 33-40 grayscale ) 
   (clutID :SIGNED-INTEGER)     ;  clut id or if 0 clut follows  or -1 if no clut 
   )

;  
;     The CodecInfo is the information returned as the codecInfo struct by a codec Component
;     to the codec manager or to the caller. It is specific to the particular codec
;     implementation and not to the codec type.

(defrecord CodecInfo 
   (typeName (:ARRAY :CHARACTER 32));  name of the codec type i.e.: 'Apple Image Compression' 
   (version :SIGNED-INTEGER)    ;  version of the codec data that this codec knows about 
   (revisionLevel :SIGNED-INTEGER);  revision level of this codec i.e: 0x00010001 (1.0.1) 
   (vendor :SIGNED-LONG)        ;  Maker of this codec i.e: 'appl' 
   (decompressFlags :SIGNED-LONG);  codecInfo flags for decompression capabilities 
   (compressFlags :SIGNED-LONG) ;  codecInfo flags for compression capabilities 
   (formatFlags :SIGNED-LONG)   ;  codecInfo flags for compression format details 
   (compressionAccuracy :CHARACTER);  measure (1-255) of accuracy of this codec for compress (0 if unknown) 
   (decompressionAccuracy :CHARACTER);  measure (1-255) of accuracy of this codec for decompress (0 if unknown) 
   (compressionSpeed :SIGNED-INTEGER);  ( millisecs for compressing 320x240 on base mac II) (0 if unknown) 
   (decompressionSpeed :SIGNED-INTEGER);  ( millisecs for decompressing 320x240 on mac II)(0 if unknown) 
   (compressionLevel :CHARACTER);  measure (1-255) of compression level of this codec (0 if unknown) 
   (resvd :CHARACTER)           ;  pad 
   (minimumHeight :SIGNED-INTEGER);  minimum height of image (block size) 
   (minimumWidth :SIGNED-INTEGER);  minimum width of image (block size) 
   (decompressPipelineLatency :SIGNED-INTEGER);  in milliseconds ( for asynchronous codecs ) 
   (compressPipelineLatency :SIGNED-INTEGER);  in milliseconds ( for asynchronous codecs ) 
   (privateData :SIGNED-LONG)
   )

;  Table used for fast dithering. 
(def-mactype :DTABPTR (find-mactype :POINTER))
(def-mactype :DTABHANDLE (find-mactype :HANDLE))
(defrecord (DitherTable :handle) 
   (tag :SIGNED-LONG)
   (seed :SIGNED-LONG)
   (reserved :SIGNED-LONG)
   (data (:ARRAY :CHARACTER 1))
   )

;  Name list returned by GetCodecNameList. 
(defrecord CodecNameSpec 
   (codec (:POINTER :COMPONENTRECORD))
   (cType :OSTYPE)
   (typeName (:ARRAY :CHARACTER 32))
   (name :HANDLE)
   )

(def-mactype :CODECNAMESPECLISTPTR (find-mactype :POINTER))
(defrecord CodecNameSpecList 
   (count :SIGNED-INTEGER)
   (list (:ARRAY :CODECNAMESPEC 1))
   )

;   Matrix stuff  
(def-mactype :MATRIXRECORDPTR (find-mactype :POINTER))
(defrecord MatrixRecord 
   (matrix (:ARRAY :SIGNED-LONG 3 3))
   )

(defrecord FixedPoint 
   (x :SIGNED-LONG)
   (y :SIGNED-LONG)
   )

(defrecord FixedRect 
   (left :SIGNED-LONG)
   (top :SIGNED-LONG)
   (right :SIGNED-LONG)
   (bottom :SIGNED-LONG)
   )


(deftrap _CODECMANAGERVERSION ((VERSION (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 0 VERSION))

(deftrap _GETCODECNAMELIST ((LIST (:POINTER (:POINTER :CODECNAMESPECLIST))) (SHOWALL :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 1 LIST SHOWALL))

(deftrap _DISPOSECODECNAMELIST ((LIST (:POINTER :CODECNAMESPECLIST)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 15 LIST))

(deftrap _GETCODECINFO ((INFO (:POINTER :CODECINFO)) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 3 INFO CTYPE CODEC))

(deftrap _GETMAXCOMPRESSIONSIZE ((SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (COLORDEPTH :SIGNED-INTEGER) (QUALITY :SIGNED-LONG) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)) (SIZE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 4 SRC SRCRECT COLORDEPTH QUALITY CTYPE CODEC SIZE))

(deftrap _GETCOMPRESSIONTIME ((SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (COLORDEPTH :SIGNED-INTEGER) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)) (SPATIALQUALITY (:POINTER :SIGNED-LONG)) (TEMPORALQUALITY (:POINTER :SIGNED-LONG)) (COMPRESSTIME (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 5 SRC SRCRECT COLORDEPTH CTYPE CODEC SPATIALQUALITY TEMPORALQUALITY COMPRESSTIME))

(deftrap _COMPRESSIMAGE ((SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (QUALITY :SIGNED-LONG) (CTYPE :OSTYPE) (DESC (:HANDLE :IMAGEDESCRIPTION)) (DATA :POINTER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 6 SRC SRCRECT QUALITY CTYPE DESC DATA))

(deftrap _FCOMPRESSIMAGE ((SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (COLORDEPTH :SIGNED-INTEGER) (QUALITY :SIGNED-LONG) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)) (CLUT (:HANDLE :COLORTABLE)) (FLAGS :SIGNED-INTEGER) (BUFFERSIZE :SIGNED-LONG) (FLUSHPROC (:POINTER :FLUSHPROCRECORD)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)) (DESC (:HANDLE :IMAGEDESCRIPTION)) (DATA :POINTER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 7 SRC SRCRECT COLORDEPTH QUALITY CTYPE CODEC CLUT FLAGS BUFFERSIZE FLUSHPROC PROGRESSPROC DESC DATA))

(deftrap _DECOMPRESSIMAGE ((DATA :POINTER) (DESC (:HANDLE :IMAGEDESCRIPTION)) (DST (:HANDLE :PIXMAP)) (SRCRECT :RECT) (DSTRECT :RECT) (MODE :SIGNED-INTEGER) (MASK (:HANDLE :REGION)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 8 DATA DESC DST SRCRECT DSTRECT MODE MASK))

(deftrap _FDECOMPRESSIMAGE ((DATA :POINTER) (DESC (:HANDLE :IMAGEDESCRIPTION)) (DST (:HANDLE :PIXMAP)) (SRCRECT :RECT) (MATRIX (:POINTER :MATRIXRECORD)) (MODE :SIGNED-INTEGER) (MASK (:HANDLE :REGION)) (MATTE (:HANDLE :PIXMAP)) (MATTERECT :RECT) (ACCURACY :SIGNED-LONG) (CODEC (:POINTER :COMPONENTRECORD)) (BUFFERSIZE :SIGNED-LONG) (DATAPROC (:POINTER :DATAPROCRECORD)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 9 DATA DESC DST SRCRECT MATRIX MODE MASK MATTE MATTERECT ACCURACY CODEC BUFFERSIZE DATAPROC PROGRESSPROC))

(deftrap _COMPRESSSEQUENCEBEGIN ((SEQID (:POINTER :SIGNED-LONG)) (SRC (:HANDLE :PIXMAP)) (PREV (:HANDLE :PIXMAP)) (SRCRECT :RECT) (PREVRECT :RECT) (COLORDEPTH :SIGNED-INTEGER) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)) (SPATIALQUALITY :SIGNED-LONG) (TEMPORALQUALITY :SIGNED-LONG) (KEYFRAMERATE :SIGNED-LONG) (CLUT (:HANDLE :COLORTABLE)) (FLAGS :SIGNED-INTEGER) (DESC (:HANDLE :IMAGEDESCRIPTION)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 10 SEQID SRC PREV SRCRECT PREVRECT COLORDEPTH CTYPE CODEC SPATIALQUALITY TEMPORALQUALITY KEYFRAMERATE CLUT FLAGS DESC))

(deftrap _COMPRESSSEQUENCEFRAME ((SEQID :SIGNED-LONG) (SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (FLAGS :SIGNED-INTEGER) (DATA :POINTER) (DATASIZE (:POINTER :SIGNED-LONG)) (SIMILARITY (:POINTER :CHARACTER)) (ASYNCCOMPLETIONPROC (:POINTER :COMPLETIONPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 11 SEQID SRC SRCRECT FLAGS DATA DATASIZE SIMILARITY ASYNCCOMPLETIONPROC))

(deftrap _DECOMPRESSSEQUENCEBEGIN ((SEQID (:POINTER :SIGNED-LONG)) (DESC (:HANDLE :IMAGEDESCRIPTION)) (PORT (:POINTER :CGRAFPORT)) (GDH (:HANDLE :GDEVICE)) (SRCRECT :RECT) (MATRIX (:POINTER :MATRIXRECORD)) (MODE :SIGNED-INTEGER) (MASK (:HANDLE :REGION)) (FLAGS :SIGNED-INTEGER) (ACCURACY :SIGNED-LONG) (CODEC (:POINTER :COMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 13 SEQID DESC PORT GDH SRCRECT MATRIX MODE MASK FLAGS ACCURACY CODEC))

(deftrap _DECOMPRESSSEQUENCEFRAME ((SEQID :SIGNED-LONG) (DATA :POINTER) (INFLAGS :SIGNED-INTEGER) (OUTFLAGS (:POINTER :SIGNED-INTEGER)) (ASYNCCOMPLETIONPROC (:POINTER :COMPLETIONPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 14 SEQID DATA INFLAGS OUTFLAGS ASYNCCOMPLETIONPROC))

(deftrap _SETDSEQUENCEMATRIX ((SEQID :SIGNED-LONG) (MATRIX (:POINTER :MATRIXRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 16 SEQID MATRIX))

(deftrap _SETDSEQUENCEMATTE ((SEQID :SIGNED-LONG) (MATTE (:HANDLE :PIXMAP)) (MATTERECT :RECT))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 17 SEQID MATTE MATTERECT))

(deftrap _SETDSEQUENCEMASK ((SEQID :SIGNED-LONG) (MASK (:HANDLE :REGION)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 18 SEQID MASK))

(deftrap _SETDSEQUENCETRANSFERMODE ((SEQID :SIGNED-LONG) (MODE :SIGNED-INTEGER) (OPCOLOR :RGBCOLOR))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 19 SEQID MODE OPCOLOR))

(deftrap _SETDSEQUENCEDATAPROC ((SEQID :SIGNED-LONG) (DATAPROC (:POINTER :DATAPROCRECORD)) (BUFFERSIZE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 20 SEQID DATAPROC BUFFERSIZE))

(deftrap _SETDSEQUENCEACCURACY ((SEQID :SIGNED-LONG) (ACCURACY :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 52 SEQID ACCURACY))

(deftrap _SETDSEQUENCESRCRECT ((SEQID :SIGNED-LONG) (SRCRECT :RECT))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 53 SEQID SRCRECT))

(deftrap _GETDSEQUENCEIMAGEBUFFER ((SEQID :SIGNED-LONG) (GWORLD (:POINTER (:POINTER :CGRAFPORT))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 21 SEQID GWORLD))

(deftrap _GETDSEQUENCESCREENBUFFER ((SEQID :SIGNED-LONG) (GWORLD (:POINTER (:POINTER :CGRAFPORT))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 22 SEQID GWORLD))

(deftrap _SETCSEQUENCEQUALITY ((SEQID :SIGNED-LONG) (SPATIALQUALITY :SIGNED-LONG) (TEMPORALQUALITY :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 23 SEQID SPATIALQUALITY TEMPORALQUALITY))

(deftrap _SETCSEQUENCEPREV ((SEQID :SIGNED-LONG) (PREV (:HANDLE :PIXMAP)) (PREVRECT :RECT))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 24 SEQID PREV PREVRECT))

(deftrap _SETCSEQUENCEFLUSHPROC ((SEQID :SIGNED-LONG) (FLUSHPROC (:POINTER :FLUSHPROCRECORD)) (BUFFERSIZE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 51 SEQID FLUSHPROC BUFFERSIZE))

(deftrap _SETCSEQUENCEKEYFRAMERATE ((SEQID :SIGNED-LONG) (KEYFRAMERATE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 54 SEQID KEYFRAMERATE))

(deftrap _GETCSEQUENCEPREVBUFFER ((SEQID :SIGNED-LONG) (GWORLD (:POINTER (:POINTER :CGRAFPORT))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 25 SEQID GWORLD))

(deftrap _CDSEQUENCEBUSY ((SEQID :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 26 SEQID))

(deftrap _CDSEQUENCEEND ((SEQID :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 27 SEQID))

(deftrap _GETCOMPRESSEDIMAGESIZE ((DESC (:HANDLE :IMAGEDESCRIPTION)) (DATA :POINTER) (BUFFERSIZE :SIGNED-LONG) (DATAPROC (:POINTER :DATAPROCRECORD)) (DATASIZE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 28 DESC DATA BUFFERSIZE DATAPROC DATASIZE))

(deftrap _GETSIMILARITY ((SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (DESC (:HANDLE :IMAGEDESCRIPTION)) (DATA :POINTER) (SIMILARITY (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 29 SRC SRCRECT DESC DATA SIMILARITY))

(deftrap _GETIMAGEDESCRIPTIONCTABLE ((DESC (:HANDLE :IMAGEDESCRIPTION)) (CTABLE (:POINTER (:HANDLE :COLORTABLE))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 30 DESC CTABLE))

(deftrap _SETIMAGEDESCRIPTIONCTABLE ((DESC (:HANDLE :IMAGEDESCRIPTION)) (CTABLE (:HANDLE :COLORTABLE)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 31 DESC CTABLE))

(deftrap _GETIMAGEDESCRIPTIONEXTENSION ((DESC (:HANDLE :IMAGEDESCRIPTION)) (EXTENSION (:POINTER :HANDLE)) (IDTYPE :SIGNED-LONG) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 32 DESC EXTENSION IDTYPE INDEX))

(deftrap _SETIMAGEDESCRIPTIONEXTENSION ((DESC (:HANDLE :IMAGEDESCRIPTION)) (EXTENSION :HANDLE) (IDTYPE :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 33 DESC EXTENSION IDTYPE))

(deftrap _FINDCODEC ((CTYPE :OSTYPE) (SPECCODEC (:POINTER :COMPONENTRECORD)) (COMPRESSOR (:POINTER (:POINTER :COMPONENTRECORD))) (DECOMPRESSOR (:POINTER (:POINTER :COMPONENTRECORD))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 35 CTYPE SPECCODEC COMPRESSOR DECOMPRESSOR))

(deftrap _COMPRESSPICTURE ((SRCPICTURE (:HANDLE :PICTURE)) (DSTPICTURE (:HANDLE :PICTURE)) (QUALITY :SIGNED-LONG) (CTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 36 SRCPICTURE DSTPICTURE QUALITY CTYPE))

(deftrap _FCOMPRESSPICTURE ((SRCPICTURE (:HANDLE :PICTURE)) (DSTPICTURE (:HANDLE :PICTURE)) (COLORDEPTH :SIGNED-INTEGER) (CLUT (:HANDLE :COLORTABLE)) (QUALITY :SIGNED-LONG) (DODITHER :SIGNED-INTEGER) (COMPRESSAGAIN :SIGNED-INTEGER) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 37 SRCPICTURE DSTPICTURE COLORDEPTH CLUT QUALITY DODITHER COMPRESSAGAIN PROGRESSPROC CTYPE CODEC))

(deftrap _COMPRESSPICTUREFILE ((SRCREFNUM :SIGNED-INTEGER) (DSTREFNUM :SIGNED-INTEGER) (QUALITY :SIGNED-LONG) (CTYPE :OSTYPE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 38 SRCREFNUM DSTREFNUM QUALITY CTYPE))

(deftrap _FCOMPRESSPICTUREFILE ((SRCREFNUM :SIGNED-INTEGER) (DSTREFNUM :SIGNED-INTEGER) (COLORDEPTH :SIGNED-INTEGER) (CLUT (:HANDLE :COLORTABLE)) (QUALITY :SIGNED-LONG) (DODITHER :SIGNED-INTEGER) (COMPRESSAGAIN :SIGNED-INTEGER) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 39 SRCREFNUM DSTREFNUM COLORDEPTH CLUT QUALITY DODITHER COMPRESSAGAIN PROGRESSPROC CTYPE CODEC))

(deftrap _GETPICTUREFILEHEADER ((REFNUM :SIGNED-INTEGER) (FRAME (:POINTER :RECT)) (HEADER (:POINTER :OPENCPICPARAMS)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 40 REFNUM FRAME HEADER))

(deftrap _DRAWPICTUREFILE ((REFNUM :SIGNED-INTEGER) (FRAME :RECT) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 41 REFNUM FRAME PROGRESSPROC))

(deftrap _DRAWTRIMMEDPICTURE ((SRCPICTURE (:HANDLE :PICTURE)) (FRAME :RECT) (TRIMMASK (:HANDLE :REGION)) (DODITHER :SIGNED-INTEGER) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 46 SRCPICTURE FRAME TRIMMASK DODITHER PROGRESSPROC))

(deftrap _DRAWTRIMMEDPICTUREFILE ((SRCREFNUM :SIGNED-INTEGER) (FRAME :RECT) (TRIMMASK (:HANDLE :REGION)) (DODITHER :SIGNED-INTEGER) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 47 SRCREFNUM FRAME TRIMMASK DODITHER PROGRESSPROC))

(deftrap _MAKETHUMBNAILFROMPICTURE ((PICTURE (:HANDLE :PICTURE)) (COLORDEPTH :SIGNED-INTEGER) (THUMBNAIL (:HANDLE :PICTURE)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 42 PICTURE COLORDEPTH THUMBNAIL PROGRESSPROC))

(deftrap _MAKETHUMBNAILFROMPICTUREFILE ((REFNUM :SIGNED-INTEGER) (COLORDEPTH :SIGNED-INTEGER) (THUMBNAIL (:HANDLE :PICTURE)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 43 REFNUM COLORDEPTH THUMBNAIL PROGRESSPROC))

(deftrap _MAKETHUMBNAILFROMPIXMAP ((SRC (:HANDLE :PIXMAP)) (SRCRECT :RECT) (COLORDEPTH :SIGNED-INTEGER) (THUMBNAIL (:HANDLE :PICTURE)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 44 SRC SRCRECT COLORDEPTH THUMBNAIL PROGRESSPROC))

(deftrap _TRIMIMAGE ((DESC (:HANDLE :IMAGEDESCRIPTION)) (INDATA :POINTER) (INBUFFERSIZE :SIGNED-LONG) (DATAPROC (:POINTER :DATAPROCRECORD)) (OUTDATA :POINTER) (OUTBUFFERSIZE :SIGNED-LONG) (FLUSHPROC (:POINTER :FLUSHPROCRECORD)) (TRIMRECT (:POINTER :RECT)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 45 DESC INDATA INBUFFERSIZE DATAPROC OUTDATA OUTBUFFERSIZE FLUSHPROC TRIMRECT PROGRESSPROC))

(deftrap _CONVERTIMAGE ((SRCDD (:HANDLE :IMAGEDESCRIPTION)) (SRCDATA :POINTER) (COLORDEPTH :SIGNED-INTEGER) (CLUT (:HANDLE :COLORTABLE)) (ACCURACY :SIGNED-LONG) (QUALITY :SIGNED-LONG) (CTYPE :OSTYPE) (CODEC (:POINTER :COMPONENTRECORD)) (DSTDD (:HANDLE :IMAGEDESCRIPTION)) (DSTDATA :POINTER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 48 SRCDD SRCDATA COLORDEPTH CLUT ACCURACY QUALITY CTYPE CODEC DSTDD DSTDATA))

(deftrap _MAKEDITHERTABLE ((GDEV (:HANDLE :GDEVICE)) (DITHERTABLE (:POINTER (:HANDLE :DITHERTABLE))))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 49 GDEV DITHERTABLE))

(deftrap _DISPOSEDITHERTABLE ((DITHERTABLE (:HANDLE :DITHERTABLE)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 50 DITHERTABLE))

(deftrap _STDPIX ((SRC (:POINTER :PIXMAP)) (SRCRECT :RECT) (MATRIX (:POINTER :MATRIXRECORD)) (MODE :SIGNED-INTEGER) (MASK (:HANDLE :REGION)) (MATTE (:POINTER :PIXMAP)) (MATTERECT :RECT) (FLAGS :SIGNED-INTEGER))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 12 SRC SRCRECT MATRIX MODE MASK MATTE MATTERECT FLAGS))


(deftrap _GETCOMPRESSEDPIXMAPINFO ((PIX (:POINTER :PIXMAP)) (DESC (:POINTER (:HANDLE :IMAGEDESCRIPTION))) (DATA (:POINTER :POINTER)) (BUFFERSIZE (:POINTER :SIGNED-LONG)) (DATAPROC (:POINTER :DATAPROCRECORD)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 55 PIX DESC DATA BUFFERSIZE DATAPROC PROGRESSPROC))

(deftrap _SETCOMPRESSEDPIXMAPINFO ((PIX (:POINTER :PIXMAP)) (DESC (:HANDLE :IMAGEDESCRIPTION)) (DATA :POINTER) (BUFFERSIZE :SIGNED-LONG) (DATAPROC (:POINTER :DATAPROCRECORD)) (PROGRESSPROC (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 56 PIX DESC DATA BUFFERSIZE DATAPROC PROGRESSPROC))

(defconstant $identityMatrixType #X0);  result if matrix is identity 
(defconstant $translateMatrixType #X1);  result if matrix translates 
(defconstant $scaleMatrixType #X2);  result if matrix scales 
(defconstant $scaleTranslateMatrixType #X3);  result if matrix scales and translates 
(defconstant $linearMatrixType #X4);  result if matrix is general 2 x 2 
(defconstant $linearTranslateMatrixType #X5);  result if matrix is general 2 x 2 and translates 
(defconstant $perspectiveMatrixType #X6);  result if matrix is general 3 x 3 

(def-mactype :MATRIXFLAGS (find-mactype :CHARACTER))


(deftrap _GETMATRIXTYPE ((M :MATRIXRECORD))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xABC2 :D0 20 M))

(deftrap _COPYMATRIX ((M1 :MATRIXRECORD) (M2 (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xABC2 :D0 32 M1 M2))

(deftrap _EQUALMATRIX ((M1 :MATRIXRECORD) (M2 :MATRIXRECORD))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xABC2 :D0 33 M1 M2))

(deftrap _SETIDENTITYMATRIX ((MATRIX (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xABC2 :D0 21 MATRIX))

(deftrap _TRANSLATEMATRIX ((M (:POINTER :MATRIXRECORD)) (DELTAH :SIGNED-LONG) (DELTAV :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xABC2 :D0 25 M DELTAH DELTAV))

(deftrap _ROTATEMATRIX ((M (:POINTER :MATRIXRECORD)) (DEGREES :SIGNED-LONG) (ABOUTX :SIGNED-LONG) (ABOUTY :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xABC2 :D0 22 M DEGREES ABOUTX ABOUTY))

(deftrap _SCALEMATRIX ((M (:POINTER :MATRIXRECORD)) (SCALEX :SIGNED-LONG) (SCALEY :SIGNED-LONG) (ABOUTX :SIGNED-LONG) (ABOUTY :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xABC2 :D0 23 M SCALEX SCALEY ABOUTX ABOUTY))

(deftrap _SKEWMATRIX ((M (:POINTER :MATRIXRECORD)) (SKEWX :SIGNED-LONG) (SKEWY :SIGNED-LONG) (ABOUTX :SIGNED-LONG) (ABOUTY :SIGNED-LONG))
   NIL
   (:STACK-TRAP #xABC2 :D0 24 M SKEWX SKEWY ABOUTX ABOUTY))

(deftrap _TRANSFORMFIXEDPOINTS ((M :MATRIXRECORD) (FPT (:POINTER :FIXEDPOINT)) (COUNT :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xABC2 :D0 34 M FPT COUNT))

(deftrap _TRANSFORMPOINTS ((MP :MATRIXRECORD) (PT1 (:POINTER :POINT)) (COUNT :SIGNED-LONG))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xABC2 :D0 35 MP PT1 COUNT))

(deftrap _TRANSFORMFIXEDRECT ((M :MATRIXRECORD) (FR (:POINTER :FIXEDRECT)) (FPP (:POINTER :FIXEDPOINT)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xABC2 :D0 36 M FR FPP))

(deftrap _TRANSFORMRECT ((M :MATRIXRECORD) (R (:POINTER :RECT)) (FPP (:POINTER :FIXEDPOINT)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xABC2 :D0 37 M R FPP))

(deftrap _TRANSFORMRGN ((MP :MATRIXRECORD) (R (:HANDLE :REGION)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 57 MP R))

(deftrap _INVERSEMATRIX ((M :MATRIXRECORD) (IM (:POINTER :MATRIXRECORD)))
   (:STACK :BOOLEAN)
   (:STACK-TRAP #xABC2 :D0 28 M IM))

(deftrap _CONCATMATRIX ((A :MATRIXRECORD) (B (:POINTER :MATRIXRECORD)))
   NIL
   (:STACK-TRAP #xABC2 :D0 27 A B))

(deftrap _RECTMATRIX ((MATRIX (:POINTER :MATRIXRECORD)) (SRCRECT :RECT) (DSTRECT :RECT))
   NIL
   (:STACK-TRAP #xABC2 :D0 30 MATRIX SRCRECT DSTRECT))

(deftrap _MAPMATRIX ((MATRIX (:POINTER :MATRIXRECORD)) (FROMRECT :RECT) (TORECT :RECT))
   NIL
   (:STACK-TRAP #xABC2 :D0 29 MATRIX FROMRECT TORECT))

;    Standard Preview  


(deftrap _SFGETFILEPREVIEW ((WHERE :POINT) (PROMPT (:STRING 255)) (FILEFILTER :POINTER) (NUMTYPES :SIGNED-INTEGER) (TYPELIST :SFTYPELIST) (DLGHOOK :POINTER) (REPLY (:POINTER :SFREPLY)))
   NIL
   (:STACK-TRAP #xAAA3 :D0 65 WHERE PROMPT FILEFILTER NUMTYPES TYPELIST DLGHOOK REPLY))


(deftrap _SFPGETFILEPREVIEW ((WHERE :POINT) (PROMPT (:STRING 255)) (FILEFILTER :POINTER) (NUMTYPES :SIGNED-INTEGER) (TYPELIST :SFTYPELIST) (DLGHOOK :POINTER) (REPLY (:POINTER :SFREPLY)) (DLGID :SIGNED-INTEGER) (FILTERPROC :POINTER))
   NIL
   (:STACK-TRAP #xAAA3 :D0 66 WHERE PROMPT FILEFILTER NUMTYPES TYPELIST DLGHOOK REPLY DLGID FILTERPROC))


(deftrap _STANDARDGETFILEPREVIEW ((FILEFILTER :POINTER) (NUMTYPES :SIGNED-INTEGER) (TYPELIST :SFTYPELIST) (REPLY (:POINTER :STANDARDFILEREPLY)))
   NIL
   (:STACK-TRAP #xAAA3 :D0 67 FILEFILTER NUMTYPES TYPELIST REPLY))


(deftrap _CUSTOMGETFILEPREVIEW ((FILEFILTER :POINTER) (NUMTYPES :SIGNED-INTEGER) (TYPELIST :SFTYPELIST) (REPLY (:POINTER :STANDARDFILEREPLY)) (DLGID :SIGNED-INTEGER) (WHERE :POINT) (DLGHOOK :POINTER) (FILTERPROC :POINTER) (ACTIVELIST :POINTER) (ACTIVATEPROC :POINTER) (YOURDATAPTR :POINTER))
   NIL
   (:STACK-TRAP #xAAA3 :D0 68 FILEFILTER NUMTYPES TYPELIST REPLY DLGID WHERE DLGHOOK FILTERPROC ACTIVELIST ACTIVATEPROC YOURDATAPTR))


(deftrap _MAKEFILEPREVIEW ((RESREFNUM :SIGNED-INTEGER) (PROGRESS (:POINTER :PROGRESSPROCRECORD)))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 69 RESREFNUM PROGRESS))


(deftrap _ADDFILEPREVIEW ((RESREFNUM :SIGNED-INTEGER) (PREVIEWTYPE :OSTYPE) (PREVIEWDATA :HANDLE))
   (:STACK :SIGNED-INTEGER)
   (:STACK-TRAP #xAAA3 :D0 70 RESREFNUM PREVIEWTYPE PREVIEWDATA))

(defconstant $sfpItemPreviewAreaUser 11)
(defconstant $sfpItemPreviewStaticText 12)
(defconstant $sfpItemPreviewDividerUser 13)
(defconstant $sfpItemCreatePreviewButton 14)
(defconstant $sfpItemShowPreviewButton 15)

(def-mactype :PREVIEWRESOURCEPTR (find-mactype :POINTER))
(def-mactype :PREVIEWRESOURCEHANDLE (find-mactype :HANDLE))
(defrecord (PreviewResourceRecord :handle) 
   (modDate :SIGNED-LONG)
   (version :SIGNED-INTEGER)
   (resType :OSTYPE)
   (resID :SIGNED-INTEGER)
   )

; $ENDC                         ;  UsingImageCompression 

; $IFC NOT UsingIncludes

; $ENDC

(export '($SFPITEMSHOWPREVIEWBUTTON $SFPITEMCREATEPREVIEWBUTTON
          $SFPITEMPREVIEWDIVIDERUSER $SFPITEMPREVIEWSTATICTEXT
          $SFPITEMPREVIEWAREAUSER $PERSPECTIVEMATRIXTYPE
          $LINEARTRANSLATEMATRIXTYPE $LINEARMATRIXTYPE
          $SCALETRANSLATEMATRIXTYPE $SCALEMATRIXTYPE $TRANSLATEMATRIXTYPE
          $IDENTITYMATRIXTYPE $CODECPROGRESSCLOSE $CODECPROGRESSUPDATEPERCENT
          $CODECPROGRESSOPEN $CODECCOMPLETIONDEST $CODECCOMPLETIONSOURCE
          $BESTCOMPRESSIONCODEC $BESTFIDELITYCODEC $BESTSPEEDCODEC $ANYCODEC
          $CODECHIGHQUALITY $CODECNORMALQUALITY $CODECLOWQUALITY
          $CODECMINQUALITY $CODECMAXQUALITY $CODECLOSSLESSQUALITY
          $DECOMPRESSORCOMPONENTTYPE $COMPRESSORCOMPONENTTYPE
          $CODECMINIMUMDATASIZE $CODECOPENERR $CODECCONDITIONERR
          $CODECDATAVERSERR $CODECBADDATAERR $CODECWOULDOFFSCREENERR
          $CODECABORTERR $CODECSPOOLERR $CODECIMAGEBUFERR $CODECSCREENBUFERR
          $CODECSIZEERR $CODECUNIMPERR $NOCODECERR $CODECERR
          $CODECFLAGUSEDIMAGEBUFFER $CODECFLAGUSEDNEWIMAGEBUFFER
          $CODECFLAGLIVEGRAB $CODECFLAGONLYSCREENUPDATE $CODECFLAGFORCEKEYFRAME
          $CODECFLAGUPDATEPREVIOUSCOMP $CODECFLAGDONTOFFSCREEN
          $CODECFLAGWASCOMPRESSED $CODECFLAGNOSCREENUPDATE
          $CODECFLAGUPDATEPREVIOUS $CODECFLAGUSESCREENBUFFER
          $CODECFLAGUSEIMAGEBUFFER $CODECINFODOESLOSSLESS $CODECINFOSTORESCLUT
          $CODECINFODEPTH40 $CODECINFODEPTH36 $CODECINFODEPTH34
          $CODECINFODEPTH33 $CODECINFODEPTH24 $CODECINFODEPTH32
          $CODECINFODEPTH16 $CODECINFODEPTH8 $CODECINFODEPTH4 $CODECINFODEPTH2
          $CODECINFODEPTH1 $CODECINFODOESSPOOL $CODECINFODOESRECOMPRESS
          $CODECINFODOESWARP $CODECINFODOESBLEND $CODECINFODOESSKEW
          $CODECINFODOESVERTFLIP $CODECINFODOESHORIZFLIP $CODECINFODOESROTATE
          $CODECINFODOESQUARTER $CODECINFODOESHALF $CODECINFODOESQUAD
          $CODECINFODOESDOUBLE $CODECINFODOESTEMPORAL $CODECINFODOESMASK
          $CODECINFODOESSHRINK $CODECINFODOESSTRETCH $CODECINFODOESDITHER
          $CODECINFODOES32 $CODECINFODOES16 $CODECINFODOES8 $CODECINFODOES4
          $CODECINFODOES2 $CODECINFODOES1 $GESTALTCOMPRESSIONMGR))
(provide-interface 'ImageCompression)