
(in-package :TRAPS)
; 
; Created: Saturday, August 17, 1991 at 10:25 AM
;  QuickTimeComponents.p
;  Pascal Interface to the Macintosh Libraries
; 
;  Copyright Apple Computer, Inc. 1991
;  All rights reserved
;     This file is used in these builds: Warhol
; 
; 
; 

; $IFC UNDEFINED UsingIncludes
; $SETC UsingIncludes := 0
; $ENDC

; $IFC NOT UsingIncludes

; $ENDC

; $IFC UNDEFINED UsingQuickTimeComponents
; $SETC UsingQuickTimeComponents := 1

; $I+
; $SETC QuickTimeComponentsIncludes := UsingIncludes
; $SETC UsingIncludes := 1
; $IFC UNDEFINED UsingComponents

(require-interface 'COMPONENTS) ; $I $$Shell(PInterfaces)Components.p
; $ENDC
; $IFC UNDEFINED UsingImageCompression

(require-interface 'IMAGECOMPRESSION); $I $$Shell(PInterfaces)ImageCompression.p
; $ENDC
; $IFC UNDEFINED UsingMovies

(require-interface 'MOVIES)     ; $I $$Shell(PInterfaces)Movies.p
; $ENDC
; $IFC UNDEFINED UsingQuickDraw

(require-interface 'QUICKDRAW)  ; $I $$Shell(PInterfaces)QuickDraw.p
; $ENDC
; $IFC UNDEFINED UsingVideo

(require-interface 'VIDEO)      ; $I $$Shell(PInterfaces)Video.p
; $ENDC
; $SETC UsingIncludes := QuickTimeComponentsIncludes

; ****
; 
;  Clock Component
; 
; ****
(defconstant $clockComponentType :|clok|)
(defconstant $systemTickClock :|tick|);  subtype: 60ths since boot 
(defconstant $systemMicrosecondClock :|micr|);  subtype: 1000000ths since boot 

(defconstant $kClockRateIsLinear 1)
(defconstant $kClockImplementsCallBacks 2)

(defconstant $kClockGetClockTimeSelect 1)
(defconstant $kClockSetClockTimeSelect 2)
(defconstant $kClockNewCallBackSelect 3)
(defconstant $kClockDisposeCallBackSelect 4)
(defconstant $kClockCallMeWhenSelect 5)
(defconstant $kClockCancelCallBackSelect 6)
(defconstant $kClockRateChangedSelect 7)
(defconstant $kClockTimeChangedSelect 8)
(defconstant $kClockSetTimeBaseSelect 9)


(deftrap _GETCLOCKTIME ((ACLOCK (:POINTER :COMPONENTINSTANCERECORD)) (OUT (:POINTER :TIMERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 ACLOCK OUT ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKNEWCALLBACK ((ACLOCK (:POINTER :COMPONENTINSTANCERECORD)) (TB (:POINTER :TIMEBASERECORD)) (CALLBACKTYPE :SIGNED-INTEGER))
   (:STACK (:POINTER :CALLBACKRECORD))
   (:STACK-TRAP #xA82A :D0 0 ACLOCK TB CALLBACKTYPE ((+ (ASH 6 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKDISPOSECALLBACK ((ACLOCK (:POINTER :COMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 ACLOCK CB ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKCALLMEWHEN ((CLOCK (:POINTER :COMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)) (PARAM1 :SIGNED-LONG) (PARAM2 :SIGNED-LONG) (PARAM3 :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB PARAM1 PARAM2 PARAM3 ((+ (ASH 16 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKCANCELCALLBACK ((CLOCK (:POINTER :COMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKRATECHANGED ((CLOCK (:POINTER :COMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKTIMECHANGED ((CLOCK (:POINTER :COMPONENTINSTANCERECORD)) (CB (:POINTER :CALLBACKRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK CB ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

(deftrap _CLOCKSETTIMEBASE ((CLOCK (:POINTER :COMPONENTINSTANCERECORD)) (TB (:POINTER :TIMEBASERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CLOCK TB ((+ (ASH 4 16) 1) :SIGNED-LONGINT)))

; 
;  Video Digitizer Component
; 
; 
;   Standard type for video digitizers 
(defconstant $videoDigitizerComponentType :|vdig|)
(defconstant $vdigInterfaceRev 2)

;  Input Format Standards 
(defconstant $ntscIn 0)         ;  ntsc input format 
(defconstant $palIn 1)          ;  pal input format 
(defconstant $secamIn 2)        ;  secam input format 

;  Input Formats 
(defconstant $compositeIn 0)    ;  input is composite format 
(defconstant $sVideoIn 1)       ;  input is sVideo format 
(defconstant $rgbComponentIn 2) ;  input is rgb component format 

;  Video Digitizer PlayThru States 
(defconstant $vdPlayThruOff 0)
(defconstant $vdPlayThruOn 1)

;  Input Color Space Modes 
(defconstant $vdDigitizerBW 0)  ;  black and white 
(defconstant $vdDigitizerRGB 1) ;  rgb color 

;  Phase Lock Loop Modes 
(defconstant $vdBroadcastMode 0);  Broadcast / Laser Disk video mode 
(defconstant $vdVTRMode 1)      ;  VCR / Magnetic media mode 

;  Field Select Options 
(defconstant $vdUseAnyField 0)
(defconstant $vdUseOddField 1)
(defconstant $vdUseEvenField 2)

;  vdig types 
(defconstant $vdTypeBasic 0)    ;  basic, no clipping 
(defconstant $vdTypeAlpha 1)    ;  supports clipping with alpha channel 
(defconstant $vdTypeMask 2)     ;  supports clipping with mask plane 
(defconstant $vdTypeKey 3)      ;  supports clipping with key color(s) 

;  Digitizer Error Codes 
(defconstant $digiUnimpErr -2201);  feature unimplemented 
(defconstant $qtParamErr -2202) ;  bad input parameter ( out of range, etc ) 
(defconstant $matrixErr -2203)  ;  bad matrix, digitizer did nothing 
(defconstant $notExactMatrix -2204);  warning of bad matrix, digitizer did its best 
(defconstant $noMoreKeyColors -2205);  all key indexes in use 
(defconstant $notExactSize -2206);  Cant do exact size requested 
(defconstant $badDepth -2207)   ;  Cant digitize into this depth 
(defconstant $noDMA -2208)      ;  Cant do DMA digitizing ( i.e. can't go to requested dest 
(defconstant $badCallOrder -2209);  Usually due to a status call being called prior to being setup first 

;  Digitizer Input Capability/Current Flags 
(defconstant $digiInDoesNTSC #X1);  digitizer supports NTSC input format 
(defconstant $digiInDoesPAL #X2);  digitizer supports PAL input format 
(defconstant $digiInDoesSECAM #X4);  digitizer supports SECAM input format 
(defconstant $digiInDoesGenLock #X80);  digitizer does genlock 

(defconstant $digiInDoesComposite #X100);  digitizer supports composite input type 
(defconstant $digiInDoesSVideo #X200);  digitizer supports S-Video input type 
(defconstant $digiInDoesComponent #X400);  digitizer supports component (rgb) input type 
(defconstant $digiInVTR_Broadcast #X800);  digitizer can differentiate between the two 

(defconstant $digiInDoesColor #X1000);  digitizer supports color 
(defconstant $digiInDoesBW #X2000);  digitizer supports black & white 

;  Digitizer Input Current Flags (these are valid only during active operating conditions) 
(defconstant $digiInSignalLock #X80000000);  digitizer detects input signal is locked - this bit = horiz lock || vertical lock 

;  Digitizer Output Capability/Current Flags 
(defconstant $digiOutDoes1 #X1) ;  digitizer supports 1 bit pixels 
(defconstant $digiOutDoes2 #X2) ;  digitizer supports 2 bit pixels 
(defconstant $digiOutDoes4 #X4) ;  digitizer supports 4 bit pixels 
(defconstant $digiOutDoes8 #X8) ;  digitizer supports 8 bit pixels 
(defconstant $digiOutDoes16 #X10);  digitizer supports 16 bit pixels 
(defconstant $digiOutDoes32 #X20);  digitizer supports 32 bit pixels 
(defconstant $digiOutDoesDither #X40);  digitizer dithers in indexed modes 
(defconstant $digiOutDoesStretch #X80);  digitizer can arbitrarily stretch 
(defconstant $digiOutDoesShrink #X100);  digitizer can arbitrarily shrink 
(defconstant $digiOutDoesMask #X200);  digitizer can mask to clipping regions 

(defconstant $digiOutDoesDouble #X800);  digitizer can stretch to exactly double size 
(defconstant $digiOutDoesQuad #X1000);  digitizer can stretch exactly quadruple size 
(defconstant $digiOutDoesQuarter #X2000);  digitizer can shrink to exactly quarter size 
(defconstant $digiOutDoesSixteenth #X4000);  digitizer can shrink to exactly sixteenth size 

(defconstant $digiOutDoesRotate #X8000);  digitizer supports rotate transformations 
(defconstant $digiOutDoesHorizFlip #X10000);  digitizer supports horizontal flips Sx < 0 
(defconstant $digiOutDoesVertFlip #X20000);  digitizer supports vertical flips Sy < 0 
(defconstant $digiOutDoesSkew #X40000);  digitizer supports skew (shear, twist) 
(defconstant $digiOutDoesBlend #X80000)
(defconstant $digiOutDoesWarp #X100000)

(defconstant $digiOutDoesHW_DMA #X200000);  digitizer not constrained to local device 
(defconstant $digiOutDoesHWPlayThru #X400000);  digitizer doesn't need time to play thru 
(defconstant $digiOutDoesILUT #X800000);  digitizer does inverse LUT for index modes 
(defconstant $digiOutDoesKeyColor #X1000000);  digitizer does key color functions too 
(defconstant $digiOutDoesAsyncGrabs #X2000000);  digitizer supports async grabs 

(def-mactype :VIDEODIGITIZERCOMPONENT (find-mactype :POINTER))
(def-mactype :VIDEODIGITIZERERROR (find-mactype :SIGNED-LONG))
(def-mactype :VDIGINTPROC (find-mactype :SIGNED-LONG))

;  Types 
(defrecord DigitizerInfo 
   (vdigType :SIGNED-INTEGER)
   (inputCapabilityFlags :SIGNED-LONG)
   (outputCapabilityFlags :SIGNED-LONG)
   (inputCurrentFlags :SIGNED-LONG)
   (outputCurrentFlags :SIGNED-LONG)
   (slot :SIGNED-INTEGER)       ;  temporary for connection purposes 
   (gdh (:HANDLE :GDEVICE))     ;  temporary for digitizers that have preferred screen 
   (maskgdh (:HANDLE :GDEVICE)) ;  temporary for digitizers that have mask planes 
   (minDestHeight :SIGNED-INTEGER);  Smallest resizable height 
   (minDestWidth :SIGNED-INTEGER);  Smallest resizable width 
   (maxDestHeight :SIGNED-INTEGER);  Largest resizable height 
   (maxDestWidth :SIGNED-INTEGER);  Largest resizable height 
   (blendLevels :SIGNED-INTEGER);  Number of blend levels supported (2 if 1 bit mask) 
   (Private :SIGNED-LONG)       ;  reserved 
   )

(defrecord VdigType 
   (digType :SIGNED-LONG)
   (Private :SIGNED-LONG)
   )

(def-mactype :VDIGTYPELISTPTR (find-mactype :POINTER))
(def-mactype :VDIGTYPELISTHANDLE (find-mactype :HANDLE))
(defrecord (VdigTypeList :handle) 
   (count :SIGNED-INTEGER)
   (list (:ARRAY :VDIGTYPE 1))
   )

(defrecord VdigBufferRec 
   (dest (:HANDLE :PIXMAP))
   (location :POINT)
   (reserved :SIGNED-LONG)
   )

(def-mactype :VDIGBUFFERRECLISTPTR (find-mactype :POINTER))
(def-mactype :VDIGBUFFERRECLISTHANDLE (find-mactype :HANDLE))
(defrecord (VdigBufferRecList :handle) 
   (count :SIGNED-INTEGER)
   (matrix (:POINTER :MATRIXRECORD))
   (mask (:HANDLE :REGION))
   (list (:ARRAY :VDIGBUFFERREC 1))
   )

;  Video Digitizer Interface 
(defconstant $kSelectVDGetMaxSrcRect 1)
(defconstant $kSelectVDGetActiveSrcRect 2)
(defconstant $kSelectVDSetDigitizerRect 3)
(defconstant $kSelectVDGetDigitizerRect 4)
(defconstant $kSelectVDGetVBlankRect 5)
(defconstant $kSelectVDGetMaskPixMap 6)
(defconstant $kSelectVDGetPlayThruDestination 8)
(defconstant $kSelectVDUseThisCLUT 9)
(defconstant $kSelectVDSetInputGammaValue 10)
(defconstant $kSelectVDGetInputGammaValue 11)
(defconstant $kSelectVDSetBrightness 12)
(defconstant $kSelectVDGetBrightness 13)
(defconstant $kSelectVDSetContrast 14)
(defconstant $kSelectVDSetHue 15)
(defconstant $kSelectVDSetSharpness 16)
(defconstant $kSelectVDSetSaturation 17)
(defconstant $kSelectVDGetContrast 18)
(defconstant $kSelectVDGetHue 19)
(defconstant $kSelectVDGetSharpness 20)
(defconstant $kSelectVDGetSaturation 21)
(defconstant $kSelectVDGrabOneFrame 22)
(defconstant $kSelectVDGetMaxAuxBuffer 23)
(defconstant $kSelectVDGetDigitizerInfo 25)
(defconstant $kSelectVDGetCurrentFlags 26)
(defconstant $kSelectVDSetKeyColor 27)
(defconstant $kSelectVDGetKeyColor 28)
(defconstant $kSelectVDAddKeyColor 29)
(defconstant $kSelectVDGetNextKeyColor 30)
(defconstant $kSelectVDSetKeyColorRange 31)
(defconstant $kSelectVDGetKeyColorRange 32)
(defconstant $kSelectVDSetDigitizerUserInterrupt 33)
(defconstant $kSelectVDSetInputColorSpaceMode 34)
(defconstant $kSelectVDGetInputColorSpaceMode 35)
(defconstant $kSelectVDSetClipState 36)
(defconstant $kSelectVDGetClipState 37)
(defconstant $kSelectVDSetClipRgn 38)
(defconstant $kSelectVDClearClipRgn 39)
(defconstant $kSelectVDGetCLUTInUse 40)
(defconstant $kSelectVDSetPLLFilterType 41)
(defconstant $kSelectVDGetPLLFilterType 42)
(defconstant $kSelectVDGetMaskandValue 43)
(defconstant $kSelectVDSetMasterBlendLevel 44)
(defconstant $kSelectVDSetPlayThruDestination 45)
(defconstant $kSelectVDSetPlayThruOnOff 46)
(defconstant $kSelectVDSetFieldPreference 47)
(defconstant $kSelectVDGetFieldPreference 48)
(defconstant $kSelectVDPreflightDestination 50)
(defconstant $kSelectVDPreflightGlobalRect 51)
(defconstant $kSelectVDSetPlayThruGlobalRect 52)
(defconstant $kSelectVDSetInputGammaRecord 53)
(defconstant $kSelectVDGetInputGammaRecord 54)
(defconstant $kSelectVDSetBlackLevelValue 55)
(defconstant $kSelectVDGetBlackLevelValue 56)
(defconstant $kSelectVDSetWhiteLevelValue 57)
(defconstant $kSelectVDGetWhiteLevelValue 58)
(defconstant $kSelectVDGetVideoDefaults 59)
(defconstant $kSelectVDGetNumberOfInputs 60)
(defconstant $kSelectVDGetInputFormat 61)
(defconstant $kSelectVDSetInput 62)
(defconstant $kSelectVDGetInput 63)
(defconstant $kSelectVDSetInputStandard 64)
(defconstant $kSelectVDSetupBuffers 65)
(defconstant $kSelectVDGrabOneFrameAsync 66)
(defconstant $kSelectVDDone 67)

(defconstant $kvdigSelectors 67)


(deftrap _VDGETMAXSRCRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTSTD :SIGNED-INTEGER) (MAXSRCRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTD MAXSRCRECT ((+ (ASH 6 16) 1) :SIGNED-LONGINT)))

(deftrap _VDGETACTIVESRCRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTSTD :SIGNED-INTEGER) (ACTIVESRCRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTD ACTIVESRCRECT ((+ (ASH 6 16) 2) :SIGNED-LONGINT)))

(deftrap _VDSETDIGITIZERRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (DIGITIZERRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DIGITIZERRECT ((+ (ASH 4 16) 3) :SIGNED-LONGINT)))

(deftrap _VDGETDIGITIZERRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (DIGITIZERRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DIGITIZERRECT ((+ (ASH 4 16) 4) :SIGNED-LONGINT)))

(deftrap _VDGETVBLANKRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTSTD :SIGNED-INTEGER) (VBLANKRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTD VBLANKRECT ((+ (ASH 6 16) 5) :SIGNED-LONGINT)))

(deftrap _VDGETMASKPIXMAP ((CI (:POINTER :COMPONENTINSTANCERECORD)) (MASKPIXMAP (:HANDLE :PIXMAP)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MASKPIXMAP ((+ (ASH 4 16) 6) :SIGNED-LONGINT)))

(deftrap _VDGETPLAYTHRUDESTINATION ((CI (:POINTER :COMPONENTINSTANCERECORD)) (DEST (:POINTER (:HANDLE :PIXMAP))) (DESTRECT (:POINTER :RECT)) (M (:POINTER :MATRIXRECORD)) (MASK (:POINTER (:HANDLE :REGION))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DEST DESTRECT M MASK ((+ (ASH 16 16) 8) :SIGNED-LONGINT)))

(deftrap _VDUSETHISCLUT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (COLORTABLEHANDLE (:HANDLE :COLORTABLE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORTABLEHANDLE ((+ (ASH 4 16) 9) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTGAMMAVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CHANNEL1 :SIGNED-LONG) (CHANNEL2 :SIGNED-LONG) (CHANNEL3 :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CHANNEL1 CHANNEL2 CHANNEL3 ((+ (ASH 12 16) 10) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTGAMMAVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CHANNEL1 (:POINTER :SIGNED-LONG)) (CHANNEL2 (:POINTER :SIGNED-LONG)) (CHANNEL3 (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CHANNEL1 CHANNEL2 CHANNEL3 ((+ (ASH 12 16) 11) :SIGNED-LONGINT)))

(deftrap _VDSETBRIGHTNESS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BRIGHTNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BRIGHTNESS ((+ (ASH 4 16) 12) :SIGNED-LONGINT)))

(deftrap _VDGETBRIGHTNESS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BRIGHTNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BRIGHTNESS ((+ (ASH 4 16) 13) :SIGNED-LONGINT)))

(deftrap _VDSETCONTRAST ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CONTRAST (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CONTRAST ((+ (ASH 4 16) 14) :SIGNED-LONGINT)))

(deftrap _VDSETHUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (HUE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI HUE ((+ (ASH 4 16) 15) :SIGNED-LONGINT)))

(deftrap _VDSETSHARPNESS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (SHARPNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SHARPNESS ((+ (ASH 4 16) 16) :SIGNED-LONGINT)))

(deftrap _VDSETSATURATION ((CI (:POINTER :COMPONENTINSTANCERECORD)) (SATURATION (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SATURATION ((+ (ASH 4 16) 17) :SIGNED-LONGINT)))

(deftrap _VDGETCONTRAST ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CONTRAST (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CONTRAST ((+ (ASH 4 16) 18) :SIGNED-LONGINT)))

(deftrap _VDGETHUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (HUE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI HUE ((+ (ASH 4 16) 19) :SIGNED-LONGINT)))

(deftrap _VDGETSHARPNESS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (SHARPNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SHARPNESS ((+ (ASH 4 16) 20) :SIGNED-LONGINT)))

(deftrap _VDGETSATURATION ((CI (:POINTER :COMPONENTINSTANCERECORD)) (SATURATION (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI SATURATION ((+ (ASH 4 16) 21) :SIGNED-LONGINT)))

(deftrap _VDGRABONEFRAME ((CI (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI ((+ (ASH 0 16) 22) :SIGNED-LONGINT)))

(deftrap _VDGETMAXAUXBUFFER ((CI (:POINTER :COMPONENTINSTANCERECORD)) (PM (:POINTER (:HANDLE :PIXMAP))) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PM R ((+ (ASH 8 16) 23) :SIGNED-LONGINT)))

(deftrap _VDGETDIGITIZERINFO ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INFO (:POINTER :DIGITIZERINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INFO ((+ (ASH 4 16) 25) :SIGNED-LONGINT)))

(deftrap _VDGETCURRENTFLAGS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTCURRENTFLAG (:POINTER :SIGNED-LONG)) (OUTPUTCURRENTFLAG (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTCURRENTFLAG OUTPUTCURRENTFLAG ((+ (ASH 8 16) 26) :SIGNED-LONGINT)))

(deftrap _VDSETKEYCOLOR ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 27) :SIGNED-LONGINT)))

(deftrap _VDGETKEYCOLOR ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INDEX (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 28) :SIGNED-LONGINT)))

(deftrap _VDADDKEYCOLOR ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INDEX (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 29) :SIGNED-LONGINT)))

(deftrap _VDGETNEXTKEYCOLOR ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INDEX :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INDEX ((+ (ASH 4 16) 30) :SIGNED-LONGINT)))

(deftrap _VDSETKEYCOLORRANGE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (MINRGB (:POINTER :RGBCOLOR)) (MAXRGB (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MINRGB MAXRGB ((+ (ASH 8 16) 31) :SIGNED-LONGINT)))

(deftrap _VDGETKEYCOLORRANGE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (MINRGB (:POINTER :RGBCOLOR)) (MAXRGB (:POINTER :RGBCOLOR)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI MINRGB MAXRGB ((+ (ASH 8 16) 32) :SIGNED-LONGINT)))

(deftrap _VDSETDIGITIZERUSERINTERRUPT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (FLAGS :SIGNED-LONG) (USERINTERRUPTPROC :SIGNED-LONG) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FLAGS USERINTERRUPTPROC REFCON ((+ (ASH 12 16) 33) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTCOLORSPACEMODE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (COLORSPACEMODE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORSPACEMODE ((+ (ASH 2 16) 34) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTCOLORSPACEMODE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (COLORSPACEMODE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORSPACEMODE ((+ (ASH 4 16) 35) :SIGNED-LONGINT)))

(deftrap _VDSETCLIPSTATE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CLIPENABLE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPENABLE ((+ (ASH 2 16) 36) :SIGNED-LONGINT)))

(deftrap _VDGETCLIPSTATE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CLIPENABLE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPENABLE ((+ (ASH 4 16) 37) :SIGNED-LONGINT)))

(deftrap _VDSETCLIPRGN ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CLIPREGION (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPREGION ((+ (ASH 4 16) 38) :SIGNED-LONGINT)))

(deftrap _VDCLEARCLIPRGN ((CI (:POINTER :COMPONENTINSTANCERECORD)) (CLIPREGION (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI CLIPREGION ((+ (ASH 4 16) 39) :SIGNED-LONGINT)))

(deftrap _VDGETCLUTINUSE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (COLORTABLEHANDLE (:POINTER (:HANDLE :COLORTABLE))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI COLORTABLEHANDLE ((+ (ASH 4 16) 40) :SIGNED-LONGINT)))

(deftrap _VDSETPLLFILTERTYPE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (PLLTYPE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PLLTYPE ((+ (ASH 2 16) 41) :SIGNED-LONGINT)))

(deftrap _VDGETPLLFILTERTYPE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (PLLTYPE (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI PLLTYPE ((+ (ASH 4 16) 42) :SIGNED-LONGINT)))

(deftrap _VDGETMASKANDVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BLENDLEVEL :SIGNED-INTEGER) (MASK (:POINTER :SIGNED-LONG)) (VALUE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLENDLEVEL MASK VALUE ((+ (ASH 10 16) 43) :SIGNED-LONGINT)))

(deftrap _VDSETMASTERBLENDLEVEL ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BLENDLEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLENDLEVEL ((+ (ASH 4 16) 44) :SIGNED-LONGINT)))

(deftrap _VDSETPLAYTHRUDESTINATION ((CI (:POINTER :COMPONENTINSTANCERECORD)) (DEST (:HANDLE :PIXMAP)) (DESTRECT (:POINTER :RECT)) (M (:POINTER :MATRIXRECORD)) (MASK (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DEST DESTRECT M MASK ((+ (ASH 16 16) 45) :SIGNED-LONGINT)))

(deftrap _VDSETPLAYTHRUONOFF ((CI (:POINTER :COMPONENTINSTANCERECORD)) (STATE :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI STATE ((+ (ASH 2 16) 46) :SIGNED-LONGINT)))

(deftrap _VDSETFIELDPREFERENCE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (FIELDFLAG :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FIELDFLAG ((+ (ASH 2 16) 47) :SIGNED-LONGINT)))

(deftrap _VDGETFIELDPREFERENCE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (FIELDFLAG (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI FIELDFLAG ((+ (ASH 4 16) 48) :SIGNED-LONGINT)))

(deftrap _VDPREFLIGHTDESTINATION ((CI (:POINTER :COMPONENTINSTANCERECORD)) (DIGITIZERRECT (:POINTER :RECT)) (DEST (:HANDLE :PIXMAP)) (DESTRECT (:POINTER :RECT)) (M (:POINTER :MATRIXRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI DIGITIZERRECT DEST DESTRECT M ((+ (ASH 16 16) 50) :SIGNED-LONGINT)))

(deftrap _VDPREFLIGHTGLOBALRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (THEWINDOW (:POINTER :GRAFPORT)) (GLOBALRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI THEWINDOW GLOBALRECT ((+ (ASH 8 16) 51) :SIGNED-LONGINT)))

(deftrap _VDSETPLAYTHRUGLOBALRECT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (THEWINDOW (:POINTER :GRAFPORT)) (GLOBALRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI THEWINDOW GLOBALRECT ((+ (ASH 8 16) 52) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTGAMMARECORD ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTGAMMAPTR (:POINTER :VDGAMMARECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTGAMMAPTR ((+ (ASH 4 16) 53) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTGAMMARECORD ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTGAMMAPTR (:POINTER (:POINTER :VDGAMMARECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTGAMMAPTR ((+ (ASH 4 16) 54) :SIGNED-LONGINT)))

(deftrap _VDSETBLACKLEVELVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BLACKLEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLACKLEVEL ((+ (ASH 4 16) 55) :SIGNED-LONGINT)))

(deftrap _VDGETBLACKLEVELVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BLACKLEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLACKLEVEL ((+ (ASH 4 16) 56) :SIGNED-LONGINT)))

(deftrap _VDSETWHITELEVELVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (WHITELEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WHITELEVEL ((+ (ASH 4 16) 57) :SIGNED-LONGINT)))

(deftrap _VDGETWHITELEVELVALUE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (WHITELEVEL (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI WHITELEVEL ((+ (ASH 4 16) 58) :SIGNED-LONGINT)))

(deftrap _VDGETVIDEODEFAULTS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BLACKLEVEL (:POINTER :SIGNED-INTEGER)) (WHITELEVEL (:POINTER :SIGNED-INTEGER)) (BRIGHTNESS (:POINTER :SIGNED-INTEGER)) (HUE (:POINTER :SIGNED-INTEGER)) (SATURATION (:POINTER :SIGNED-INTEGER)) (CONTRAST (:POINTER :SIGNED-INTEGER)) (SHARPNESS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BLACKLEVEL WHITELEVEL BRIGHTNESS HUE SATURATION CONTRAST SHARPNESS ((+ (ASH 28 16) 59) :SIGNED-LONGINT)))

(deftrap _VDGETNUMBEROFINPUTS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTS (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTS ((+ (ASH 4 16) 60) :SIGNED-LONGINT)))

(deftrap _VDGETINPUTFORMAT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUT :SIGNED-INTEGER) (FORMAT (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUT FORMAT ((+ (ASH 6 16) 61) :SIGNED-LONGINT)))

(deftrap _VDSETINPUT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUT :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUT ((+ (ASH 2 16) 62) :SIGNED-LONGINT)))

(deftrap _VDGETINPUT ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUT (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUT ((+ (ASH 4 16) 63) :SIGNED-LONGINT)))

(deftrap _VDSETINPUTSTANDARD ((CI (:POINTER :COMPONENTINSTANCERECORD)) (INPUTSTANDARD :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI INPUTSTANDARD ((+ (ASH 2 16) 64) :SIGNED-LONGINT)))

(deftrap _VDSETUPBUFFERS ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERLIST (:HANDLE :VDIGBUFFERRECLIST)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFERLIST ((+ (ASH 4 16) 65) :SIGNED-LONGINT)))

(deftrap _VDGRABONEFRAMEASYNC ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BUFFER :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFER ((+ (ASH 2 16) 66) :SIGNED-LONGINT)))

(deftrap _VDDONE ((CI (:POINTER :COMPONENTINSTANCERECORD)) (BUFFER :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 CI BUFFER ((+ (ASH 2 16) 67) :SIGNED-LONGINT)))

;  Sequence Grab Component 
(def-mactype :SEQGRABCOMPONENT (find-mactype :POINTER))
(def-mactype :SGCHANNEL (find-mactype :POINTER))

(defconstant $SeqGrabComponentType :|barg|)
(defconstant $SeqGrabChannelType :|sgch|)
(defconstant $grabPictOffScreen 1)
(defconstant $sgFlagControlledGrab 1)

(defconstant $channelPlayNormal 0)
(defconstant $channelPlayFast 1)
(defconstant $channelPlayHighQuality 2)
(defconstant $channelPlayAllData 4)

(defconstant $seqGrabToDisk 1)
(defconstant $seqGrabToMemory 2)
(defconstant $seqGrabUseTempMemory 4)
(defconstant $seqGrabAppendToFile 8)
(defconstant $seqGrabDontAddMovieResource 16)
(defconstant $seqGrabRecord 1)
(defconstant $seqGrabPreview 2)
(defconstant $seqGrabPlayDuringRecord 4)
(defconstant $seqGrabHasBounds 1)
(defconstant $seqGrabHasVolume 2)
(defconstant $seqGrabHasDiscreteSamples 4)

(defconstant $noDeviceForChannel -9400)
(defconstant $grabTimeComplete -9401)
(defconstant $cantDoThatInCurrentMode -9402)
(defconstant $notEnoughMemoryToGrab -9403)
(defconstant $notEnoughDiskSpaceToGrab -9404)
(defconstant $couldntGetRequiredComponent -9405)
(defconstant $badSGChannel -9406)
(defconstant $seqGrabInfoNotAvailable -9407)
(defconstant $deviceCantMeetRequest -9408)

(defrecord SeqGrabFrameInfo 
   (frameOffset :SIGNED-LONG)
   (frameTime :SIGNED-LONG)
   (frameSize :SIGNED-LONG)
   (frameChannel (:POINTER :COMPONENTINSTANCERECORD))
   (frameRefCon :SIGNED-LONG)
   )


(deftrap _SGINITIALIZE ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 1) :SIGNED-LONGINT)))


(deftrap _SGSETDATAOUTPUT ((S (:POINTER :COMPONENTINSTANCERECORD)) (MOVIEFILE :FSSPEC) (WHEREFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S MOVIEFILE WHEREFLAGS ((+ (ASH 8 16) 2) :SIGNED-LONGINT)))

(deftrap _SGGETDATAOUTPUT ((S (:POINTER :COMPONENTINSTANCERECORD)) (MOVIEFILE (:POINTER :FSSPEC)) (WHEREFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S MOVIEFILE WHEREFLAGS ((+ (ASH 8 16) 3) :SIGNED-LONGINT)))


(deftrap _SGSETGWORLD ((S (:POINTER :COMPONENTINSTANCERECORD)) (GP (:POINTER :CGRAFPORT)) (GD (:HANDLE :GDEVICE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S GP GD ((+ (ASH 8 16) 4) :SIGNED-LONGINT)))

(deftrap _SGGETGWORLD ((S (:POINTER :COMPONENTINSTANCERECORD)) (GP (:POINTER (:POINTER :CGRAFPORT))) (GD (:POINTER (:HANDLE :GDEVICE))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S GP GD ((+ (ASH 8 16) 5) :SIGNED-LONGINT)))


(deftrap _SGNEWCHANNEL ((S (:POINTER :COMPONENTINSTANCERECORD)) (CHANNELTYPE :OSTYPE) (REF (:POINTER (:POINTER :COMPONENTINSTANCERECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S CHANNELTYPE REF ((+ (ASH 8 16) 6) :SIGNED-LONGINT)))

(deftrap _SGDISPOSECHANNEL ((S (:POINTER :COMPONENTINSTANCERECORD)) (C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C ((+ (ASH 4 16) 7) :SIGNED-LONGINT)))


(deftrap _SGSTARTPREVIEW ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 16) :SIGNED-LONGINT)))

(deftrap _SGSTARTRECORD ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 17) :SIGNED-LONGINT)))

(deftrap _SGIDLE ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 18) :SIGNED-LONGINT)))

(deftrap _SGSTOP ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 19) :SIGNED-LONGINT)))


(deftrap _SGPAUSE ((S (:POINTER :COMPONENTINSTANCERECORD)) (PAUSE :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S PAUSE ((+ (ASH 2 16) 20) :SIGNED-LONGINT)))


(deftrap _SGPREPARE ((S (:POINTER :COMPONENTINSTANCERECORD)) (PREPAREFORPREVIEW :BOOLEAN) (PREPAREFORRECORD :BOOLEAN))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S PREPAREFORPREVIEW PREPAREFORRECORD ((+ (ASH 4 16) 21) :SIGNED-LONGINT)))

(deftrap _SGRELEASE ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 22) :SIGNED-LONGINT)))


(deftrap _SGGETMOVIE ((S (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :MOVIERECORD))
   (:STACK-TRAP #xA82A :D0 0 S ((+ (ASH 0 16) 23) :SIGNED-LONGINT)))


(deftrap _SGSETMAXIMUMRECORDTIME ((S (:POINTER :COMPONENTINSTANCERECORD)) (TICKS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TICKS ((+ (ASH 4 16) 24) :SIGNED-LONGINT)))

(deftrap _SGGETMAXIMUMRECORDTIME ((S (:POINTER :COMPONENTINSTANCERECORD)) (TICKS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TICKS ((+ (ASH 4 16) 25) :SIGNED-LONGINT)))


(deftrap _SGGETSTORAGESPACEREMAINING ((S (:POINTER :COMPONENTINSTANCERECORD)) (BYTES (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S BYTES ((+ (ASH 4 16) 26) :SIGNED-LONGINT)))

(deftrap _SGGETTIMEREMAINING ((S (:POINTER :COMPONENTINSTANCERECORD)) (TICKSLEFT (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TICKSLEFT ((+ (ASH 4 16) 27) :SIGNED-LONGINT)))


(deftrap _SGGRABPICT ((S (:POINTER :COMPONENTINSTANCERECORD)) (P (:POINTER (:HANDLE :PICTURE))) (BOUNDS :RECT) (OFFSCREENDEPTH :SIGNED-INTEGER) (GRABPICTFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S P BOUNDS OFFSCREENDEPTH GRABPICTFLAGS ((+ (ASH 14 16) 28) :SIGNED-LONGINT)))


(deftrap _SGGETLASTMOVIERESID ((S (:POINTER :COMPONENTINSTANCERECORD)) (RESID (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S RESID ((+ (ASH 4 16) 29) :SIGNED-LONGINT)))


(deftrap _SGSETFLAGS ((S (:POINTER :COMPONENTINSTANCERECORD)) (SGFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S SGFLAGS ((+ (ASH 4 16) 30) :SIGNED-LONGINT)))


(deftrap _SGGETFLAGS ((S (:POINTER :COMPONENTINSTANCERECORD)) (SGFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S SGFLAGS ((+ (ASH 4 16) 31) :SIGNED-LONGINT)))

;    General Channel Routines   

(deftrap _SGSETCHANNELUSAGE ((C (:POINTER :COMPONENTINSTANCERECORD)) (USAGE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C USAGE ((+ (ASH 4 16) 128) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELUSAGE ((C (:POINTER :COMPONENTINSTANCERECORD)) (USAGE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C USAGE ((+ (ASH 4 16) 129) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELBOUNDS ((C (:POINTER :COMPONENTINSTANCERECORD)) (BOUNDS :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BOUNDS ((+ (ASH 4 16) 130) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELBOUNDS ((C (:POINTER :COMPONENTINSTANCERECORD)) (BOUNDS (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BOUNDS ((+ (ASH 4 16) 131) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELVOLUME ((C (:POINTER :COMPONENTINSTANCERECORD)) (VOLUME :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VOLUME ((+ (ASH 2 16) 132) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELVOLUME ((C (:POINTER :COMPONENTINSTANCERECORD)) (VOLUME (:POINTER :SIGNED-INTEGER)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VOLUME ((+ (ASH 4 16) 133) :SIGNED-LONGINT)))


(deftrap _SGGETCHANNELINFO ((C (:POINTER :COMPONENTINSTANCERECORD)) (CHANNELINFO (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C CHANNELINFO ((+ (ASH 4 16) 134) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELPLAYFLAGS ((C (:POINTER :COMPONENTINSTANCERECORD)) (PLAYFLAGS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C PLAYFLAGS ((+ (ASH 4 16) 135) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELPLAYFLAGS ((C (:POINTER :COMPONENTINSTANCERECORD)) (PLAYFLAGS (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C PLAYFLAGS ((+ (ASH 4 16) 136) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELMAXFRAMES ((C (:POINTER :COMPONENTINSTANCERECORD)) (FRAMECOUNT :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C FRAMECOUNT ((+ (ASH 4 16) 137) :SIGNED-LONGINT)))

(deftrap _SGGETCHANNELMAXFRAMES ((C (:POINTER :COMPONENTINSTANCERECORD)) (FRAMECOUNT (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C FRAMECOUNT ((+ (ASH 4 16) 138) :SIGNED-LONGINT)))


(deftrap _SGSETCHANNELREFCON ((C (:POINTER :COMPONENTINSTANCERECORD)) (REFCON :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C REFCON ((+ (ASH 4 16) 139) :SIGNED-LONGINT)))

;  Video Routines 

(def-mactype :GRABPROC (find-mactype :SIGNED-LONG))
(def-mactype :GRABCOMPLETEPROC (find-mactype :SIGNED-LONG))
(def-mactype :DISPLAYPROC (find-mactype :SIGNED-LONG))
(def-mactype :COMPRESSPROC (find-mactype :SIGNED-LONG))
(def-mactype :COMPRESSCOMPLETEPROC (find-mactype :SIGNED-LONG))
(def-mactype :ADDFRAMEPROC (find-mactype :SIGNED-LONG))
(def-mactype :TRANSFERFRAMEPROC (find-mactype :SIGNED-LONG))

(defrecord VideoBottles 
   (procCount :SIGNED-INTEGER)
   (GrabProc :SIGNED-LONG)
   (GrabCompleteProc :SIGNED-LONG)
   (DisplayProc :SIGNED-LONG)
   (CompressProc :SIGNED-LONG)
   (AddFrameProc :SIGNED-LONG)
   (TransferFrameProc :SIGNED-LONG)
   )

(defrecord SGCompressInfo 
   (buffer :POINTER)
   (bufferSize :SIGNED-LONG)
   (similarity :CHARACTER)
   (reserved :CHARACTER)
   )


(deftrap _SGGETSRCVIDEOBOUNDS ((C (:POINTER :COMPONENTINSTANCERECORD)) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 256) :SIGNED-LONGINT)))

(deftrap _SGSETVIDEORECT ((C (:POINTER :COMPONENTINSTANCERECORD)) (R :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 257) :SIGNED-LONGINT)))

(deftrap _SGGETVIDEORECT ((C (:POINTER :COMPONENTINSTANCERECORD)) (R (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C R ((+ (ASH 4 16) 258) :SIGNED-LONGINT)))


(deftrap _SGGETVIDEOCOMPRESSORTYPE ((C (:POINTER :COMPONENTINSTANCERECORD)) (COMPRESSORTYPE (:POINTER :OSTYPE)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C COMPRESSORTYPE ((+ (ASH 4 16) 259) :SIGNED-LONGINT)))

(deftrap _SGSETVIDEOCOMPRESSORTYPE ((C (:POINTER :COMPONENTINSTANCERECORD)) (COMPRESSORTYPE :OSTYPE))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C COMPRESSORTYPE ((+ (ASH 4 16) 260) :SIGNED-LONGINT)))


(deftrap _SGSETVIDEOCOMPRESSOR ((C (:POINTER :COMPONENTINSTANCERECORD)) (DEPTH :SIGNED-INTEGER) (COMPRESSOR (:POINTER :COMPONENTRECORD)) (SPATIALQUALITY :SIGNED-LONG) (TEMPORALQUALITY :SIGNED-LONG) (KEYFRAMERATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSOR SPATIALQUALITY TEMPORALQUALITY KEYFRAMERATE ((+ (ASH 18 16) 261) :SIGNED-LONGINT)))

(deftrap _SGGETVIDEOCOMPRESSOR ((C (:POINTER :COMPONENTINSTANCERECORD)) (DEPTH (:POINTER :SIGNED-INTEGER)) (COMPRESSOR (:POINTER (:POINTER :COMPONENTRECORD))) (SPATIALQUALITY (:POINTER :SIGNED-LONG)) (TEMPORALQUALITY (:POINTER :SIGNED-LONG)) (KEYFRAMERATE (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSOR SPATIALQUALITY TEMPORALQUALITY KEYFRAMERATE ((+ (ASH 20 16) 262) :SIGNED-LONGINT)))


(deftrap _SGGETVIDEODIGITIZERCOMPONENT ((C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK (:POINTER :COMPONENTINSTANCERECORD))
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 263) :SIGNED-LONGINT)))

(deftrap _SGSETVIDEODIGITIZERCOMPONENT ((C (:POINTER :COMPONENTINSTANCERECORD)) (VDIG (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VDIG ((+ (ASH 4 16) 264) :SIGNED-LONGINT)))

(deftrap _SGVIDEODIGITIZERCHANGED ((C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 265) :SIGNED-LONGINT)))


(deftrap _SGSETVIDEOBOTTLENECKS ((C (:POINTER :COMPONENTINSTANCERECORD)) (VB (:POINTER :VIDEOBOTTLES)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VB ((+ (ASH 4 16) 266) :SIGNED-LONGINT)))

(deftrap _SGGETVIDEOBOTTLENECKS ((C (:POINTER :COMPONENTINSTANCERECORD)) (VB (:POINTER :VIDEOBOTTLES)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C VB ((+ (ASH 4 16) 267) :SIGNED-LONGINT)))


(deftrap _SGGRABFRAME ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM ((+ (ASH 2 16) 268) :SIGNED-LONGINT)))

(deftrap _SGGRABFRAMECOMPLETE ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (DONE (:POINTER :BOOLEAN)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM DONE ((+ (ASH 6 16) 269) :SIGNED-LONGINT)))


(deftrap _SGDISPLAYFRAME ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (MP :MATRIXRECORD) (CLIPRGN (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM MP CLIPRGN ((+ (ASH 10 16) 270) :SIGNED-LONGINT)))

(deftrap _SGCOMPRESSFRAME ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM ((+ (ASH 2 16) 271) :SIGNED-LONGINT)))

(deftrap _SGCOMPRESSFRAMECOMPLETE ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (DONE (:POINTER :BOOLEAN)) (CI (:POINTER :SGCOMPRESSINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM DONE CI ((+ (ASH 10 16) 272) :SIGNED-LONGINT)))

(deftrap _SGADDFRAME ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (ATTIME :SIGNED-LONG) (SCALE :SIGNED-LONG) (CI :SGCOMPRESSINFO))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM ATTIME SCALE CI ((+ (ASH 14 16) 273) :SIGNED-LONGINT)))


(deftrap _SGTRANSFERFRAMEFORCOMPRESS ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (MP :MATRIXRECORD) (CLIPRGN (:HANDLE :REGION)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM MP CLIPRGN ((+ (ASH 10 16) 274) :SIGNED-LONGINT)))


(deftrap _SGSETCOMPRESSBUFFER ((C (:POINTER :COMPONENTINSTANCERECORD)) (DEPTH :SIGNED-INTEGER) (COMPRESSSIZE :RECT))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSSIZE ((+ (ASH 6 16) 275) :SIGNED-LONGINT)))


(deftrap _SGGETCOMPRESSBUFFER ((C (:POINTER :COMPONENTINSTANCERECORD)) (DEPTH (:POINTER :SIGNED-INTEGER)) (COMPRESSSIZE (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DEPTH COMPRESSSIZE ((+ (ASH 8 16) 276) :SIGNED-LONGINT)))


(deftrap _SGGETBUFFERINFO ((C (:POINTER :COMPONENTINSTANCERECORD)) (BUFFERNUM :SIGNED-INTEGER) (BUFFERPM (:POINTER (:HANDLE :PIXMAP))) (BUFFERRECT (:POINTER :RECT)) (COMPRESSBUFFER (:POINTER (:POINTER :CGRAFPORT))) (COMPRESSBUFFERRECT (:POINTER :RECT)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BUFFERNUM BUFFERPM BUFFERRECT COMPRESSBUFFER COMPRESSBUFFERRECT ((+ (ASH 18 16) 277) :SIGNED-LONGINT)))

;    Sound Routines   

(deftrap _SGSETSOUNDINPUTDRIVER ((C (:POINTER :COMPONENTINSTANCERECORD)) (DRIVERNAME (:STRING 255)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C DRIVERNAME ((+ (ASH 4 16) 256) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDINPUTDRIVER ((C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 257) :SIGNED-LONGINT)))

(deftrap _SGSOUNDINPUTDRIVERCHANGED ((C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 258) :SIGNED-LONGINT)))


(deftrap _SGSETSOUNDRECORDCHUNKSIZE ((C (:POINTER :COMPONENTINSTANCERECORD)) (SECONDS :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C SECONDS ((+ (ASH 4 16) 259) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDRECORDCHUNKSIZE ((C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 260) :SIGNED-LONGINT)))


(deftrap _SGSETSOUNDINPUTRATE ((C (:POINTER :COMPONENTINSTANCERECORD)) (RATE :SIGNED-LONG))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C RATE ((+ (ASH 4 16) 261) :SIGNED-LONGINT)))

(deftrap _SGGETSOUNDINPUTRATE ((C (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C ((+ (ASH 0 16) 262) :SIGNED-LONGINT)))

;    calls from seqGrab to Channel   

(deftrap _SGINITCHANNEL ((C (:POINTER :COMPONENTINSTANCERECORD)) (OWNER (:POINTER :COMPONENTINSTANCERECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C OWNER ((+ (ASH 4 16) 384) :SIGNED-LONGINT)))

(deftrap _SGWRITESAMPLES ((C (:POINTER :COMPONENTINSTANCERECORD)) (M (:POINTER :MOVIERECORD)) (THEFILE (:HANDLE :ALIASRECORD)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C M THEFILE ((+ (ASH 8 16) 385) :SIGNED-LONGINT)))

(deftrap _SGGETDATARATE ((C (:POINTER :COMPONENTINSTANCERECORD)) (BYTESPERSECOND (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 C BYTESPERSECOND ((+ (ASH 4 16) 386) :SIGNED-LONGINT)))

;    calls from Channel to seqGrab   

(deftrap _SGWRITEMOVIEDATA ((S (:POINTER :COMPONENTINSTANCERECORD)) (C (:POINTER :COMPONENTINSTANCERECORD)) (P :POINTER) (LEN :SIGNED-LONG) (OFFSET (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S C P LEN OFFSET ((+ (ASH 16 16) 128) :SIGNED-LONGINT)))

(deftrap _SGADDFRAMEREFERENCE ((S (:POINTER :COMPONENTINSTANCERECORD)) (FRAMEINFO (:POINTER :SEQGRABFRAMEINFO)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S FRAMEINFO ((+ (ASH 4 16) 129) :SIGNED-LONGINT)))

(deftrap _SGGETNEXTFRAMEREFERENCE ((S (:POINTER :COMPONENTINSTANCERECORD)) (FRAMEINFO (:POINTER :SEQGRABFRAMEINFO)) (FRAMEDURATION (:POINTER :SIGNED-LONG)) (FRAMENUMBER (:POINTER :SIGNED-LONG)))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S FRAMEINFO FRAMEDURATION FRAMENUMBER ((+ (ASH 12 16) 130) :SIGNED-LONGINT)))

(deftrap _SGGETTIMEBASE ((S (:POINTER :COMPONENTINSTANCERECORD)) (TB (:POINTER (:POINTER :TIMEBASERECORD))))
   (:STACK :SIGNED-LONG)
   (:STACK-TRAP #xA82A :D0 0 S TB ((+ (ASH 4 16) 131) :SIGNED-LONGINT)))

(defconstant $kSGInitializeSelect #X1)
(defconstant $kSGSetDataOutputSelect #X2)
(defconstant $kSGGetDataOutputSelect #X3)
(defconstant $kSGSetGWorldSelect #X4)
(defconstant $kSGGetGWorldSelect #X5)
(defconstant $kSGNewChannelSelect #X6)
(defconstant $kSGDisposeChannelSelect #X7)
(defconstant $kSGStartPreviewSelect #X10)
(defconstant $kSGStartRecordSelect #X11)
(defconstant $kSGIdleSelect #X12)
(defconstant $kSGStopSelect #X13)
(defconstant $kSGPauseSelect #X14)
(defconstant $kSGPrepareSelect #X15)
(defconstant $kSGReleaseSelect #X16)
(defconstant $kSGGetMovieSelect #X17)
(defconstant $kSGSetMaximumRecordTimeSelect #X18)
(defconstant $kSGGetMaximumRecordTimeSelect #X19)
(defconstant $kSGGetStorageSpaceRemainingSelect #X1A)
(defconstant $kSGGetTimeRemainingSelect #X1B)
(defconstant $kSGGrabPictSelect #X1C)
(defconstant $kSGGetLastMovieResIDSelect #X1D)
(defconstant $kSGSetFlagsSelect #X1E)
(defconstant $kSGGetFlagsSelect #X1F)

(defconstant $kSGCSetChannelUsageSelect #X80)
(defconstant $kSGCGetChannelUsageSelect #X81)
(defconstant $kSGCSetChannelBoundsSelect #X82)
(defconstant $kSGCGetChannelBoundsSelect #X83)
(defconstant $kSGCSetChannelVolumeSelect #X84)
(defconstant $kSGCGetChannelVolumeSelect #X85)
(defconstant $kSGCGetChannelInfoSelect #X86)
(defconstant $kSGCSetChannelPlayFlagsSelect #X87)
(defconstant $kSGCGetChannelPlayFlagsSelect #X88)
(defconstant $kSGCSetChannelMaxFramesSelect #X89)
(defconstant $kSGCGetChannelMaxFramesSelect #X8A)
(defconstant $kSGCSetChannelRefConSelect #X8B)

(defconstant $kSGCGetSrcVideoBoundsSelect #X100)
(defconstant $kSGCSetVideoRectSelect #X101)
(defconstant $kSGCGetVideoRectSelect #X102)
(defconstant $kSGCGetVideoCompressorTypeSelect #X103)
(defconstant $kSGCSetVideoCompressorTypeSelect #X104)
(defconstant $kSGCSetVideoCompressorSelect #X105)
(defconstant $kSGCGetVideoCompressorSelect #X106)
(defconstant $kSGCGetVideoDigitizerComponentSelect #X107)
(defconstant $kSGCSetVideoDigitizerComponentSelect #X108)
(defconstant $kSGCVideoDigitizerChangedSelect #X109)
(defconstant $kSGCSetVideoBottlenecksSelect #X10A)
(defconstant $kSGCGetVideoBottlenecksSelect #X10B)
(defconstant $kSGCGrabFrameSelect #X10C)
(defconstant $kSGCGrabFrameCompleteSelect #X10D)
(defconstant $kSGCDisplayFrameSelect #X10E)
(defconstant $kSGCCompressFrameSelect #X10F)
(defconstant $kSGCCompressFrameCompleteSelect #X110)
(defconstant $kSGCAddFrameSelect #X111)
(defconstant $kSGCTransferFrameForCompressSelect #X112)
(defconstant $kSGCSetCompressBufferSelect #X113)
(defconstant $kSGCGetCompressBufferSelect #X114)
(defconstant $kSGCGetBufferInfoSelect #X115)

(defconstant $kSGCSetSoundInputDriverSelect #X100)
(defconstant $kSGCGetSoundInputDriverSelect #X101)
(defconstant $kSGCSoundInputDriverChangedSelect #X102)
(defconstant $kSGCSetSoundRecordChunkSizeSelect #X103)
(defconstant $kSGCGetSoundRecordChunkSizeSelect #X104)
(defconstant $kSGCSetSoundInputRateSelect #X105)
(defconstant $kSGCGetSoundInputRateSelect #X106)

(defconstant $kSGCInitChannelSelect #X180)
(defconstant $kSGCWriteSamplesSelect #X181)
(defconstant $kSGCGetDataRateSelect #X182)

(defconstant $kSGWriteMovieDataSelect #X80)
(defconstant $kSGAddFrameReferenceSelect #X81)
(defconstant $kSGGetNextFrameReferenceSelect #X82)
(defconstant $kSGGetTimeBaseSelect #X83)

; $ENDC                         ;  UsingQuickTimeComponents 

; $IFC NOT UsingIncludes

; $ENDC


(export '($KSGGETTIMEBASESELECT $KSGGETNEXTFRAMEREFERENCESELECT
          $KSGADDFRAMEREFERENCESELECT $KSGWRITEMOVIEDATASELECT
          $KSGCGETDATARATESELECT $KSGCWRITESAMPLESSELECT $KSGCINITCHANNELSELECT
          $KSGCGETSOUNDINPUTRATESELECT $KSGCSETSOUNDINPUTRATESELECT
          $KSGCGETSOUNDRECORDCHUNKSIZESELECT $KSGCSETSOUNDRECORDCHUNKSIZESELECT
          $KSGCSOUNDINPUTDRIVERCHANGEDSELECT $KSGCGETSOUNDINPUTDRIVERSELECT
          $KSGCSETSOUNDINPUTDRIVERSELECT $KSGCGETBUFFERINFOSELECT
          $KSGCGETCOMPRESSBUFFERSELECT $KSGCSETCOMPRESSBUFFERSELECT
          $KSGCTRANSFERFRAMEFORCOMPRESSSELECT $KSGCADDFRAMESELECT
          $KSGCCOMPRESSFRAMECOMPLETESELECT $KSGCCOMPRESSFRAMESELECT
          $KSGCDISPLAYFRAMESELECT $KSGCGRABFRAMECOMPLETESELECT
          $KSGCGRABFRAMESELECT $KSGCGETVIDEOBOTTLENECKSSELECT
          $KSGCSETVIDEOBOTTLENECKSSELECT $KSGCVIDEODIGITIZERCHANGEDSELECT
          $KSGCSETVIDEODIGITIZERCOMPONENTSELECT
          $KSGCGETVIDEODIGITIZERCOMPONENTSELECT $KSGCGETVIDEOCOMPRESSORSELECT
          $KSGCSETVIDEOCOMPRESSORSELECT $KSGCSETVIDEOCOMPRESSORTYPESELECT
          $KSGCGETVIDEOCOMPRESSORTYPESELECT $KSGCGETVIDEORECTSELECT
          $KSGCSETVIDEORECTSELECT $KSGCGETSRCVIDEOBOUNDSSELECT
          $KSGCSETCHANNELREFCONSELECT $KSGCGETCHANNELMAXFRAMESSELECT
          $KSGCSETCHANNELMAXFRAMESSELECT $KSGCGETCHANNELPLAYFLAGSSELECT
          $KSGCSETCHANNELPLAYFLAGSSELECT $KSGCGETCHANNELINFOSELECT
          $KSGCGETCHANNELVOLUMESELECT $KSGCSETCHANNELVOLUMESELECT
          $KSGCGETCHANNELBOUNDSSELECT $KSGCSETCHANNELBOUNDSSELECT
          $KSGCGETCHANNELUSAGESELECT $KSGCSETCHANNELUSAGESELECT
          $KSGGETFLAGSSELECT $KSGSETFLAGSSELECT $KSGGETLASTMOVIERESIDSELECT
          $KSGGRABPICTSELECT $KSGGETTIMEREMAININGSELECT
          $KSGGETSTORAGESPACEREMAININGSELECT $KSGGETMAXIMUMRECORDTIMESELECT
          $KSGSETMAXIMUMRECORDTIMESELECT $KSGGETMOVIESELECT $KSGRELEASESELECT
          $KSGPREPARESELECT $KSGPAUSESELECT $KSGSTOPSELECT $KSGIDLESELECT
          $KSGSTARTRECORDSELECT $KSGSTARTPREVIEWSELECT $KSGDISPOSECHANNELSELECT
          $KSGNEWCHANNELSELECT $KSGGETGWORLDSELECT $KSGSETGWORLDSELECT
          $KSGGETDATAOUTPUTSELECT $KSGSETDATAOUTPUTSELECT $KSGINITIALIZESELECT
          $DEVICECANTMEETREQUEST $SEQGRABINFONOTAVAILABLE $BADSGCHANNEL
          $COULDNTGETREQUIREDCOMPONENT $NOTENOUGHDISKSPACETOGRAB
          $NOTENOUGHMEMORYTOGRAB $CANTDOTHATINCURRENTMODE $GRABTIMECOMPLETE
          $NODEVICEFORCHANNEL $SEQGRABHASDISCRETESAMPLES $SEQGRABHASVOLUME
          $SEQGRABHASBOUNDS $SEQGRABPLAYDURINGRECORD $SEQGRABPREVIEW
          $SEQGRABRECORD $SEQGRABDONTADDMOVIERESOURCE $SEQGRABAPPENDTOFILE
          $SEQGRABUSETEMPMEMORY $SEQGRABTOMEMORY $SEQGRABTODISK
          $CHANNELPLAYALLDATA $CHANNELPLAYHIGHQUALITY $CHANNELPLAYFAST
          $CHANNELPLAYNORMAL $SGFLAGCONTROLLEDGRAB $GRABPICTOFFSCREEN
          $SEQGRABCHANNELTYPE $SEQGRABCOMPONENTTYPE $KVDIGSELECTORS
          $KSELECTVDDONE $KSELECTVDGRABONEFRAMEASYNC $KSELECTVDSETUPBUFFERS
          $KSELECTVDSETINPUTSTANDARD $KSELECTVDGETINPUT $KSELECTVDSETINPUT
          $KSELECTVDGETINPUTFORMAT $KSELECTVDGETNUMBEROFINPUTS
          $KSELECTVDGETVIDEODEFAULTS $KSELECTVDGETWHITELEVELVALUE
          $KSELECTVDSETWHITELEVELVALUE $KSELECTVDGETBLACKLEVELVALUE
          $KSELECTVDSETBLACKLEVELVALUE $KSELECTVDGETINPUTGAMMARECORD
          $KSELECTVDSETINPUTGAMMARECORD $KSELECTVDSETPLAYTHRUGLOBALRECT
          $KSELECTVDPREFLIGHTGLOBALRECT $KSELECTVDPREFLIGHTDESTINATION
          $KSELECTVDGETFIELDPREFERENCE $KSELECTVDSETFIELDPREFERENCE
          $KSELECTVDSETPLAYTHRUONOFF $KSELECTVDSETPLAYTHRUDESTINATION
          $KSELECTVDSETMASTERBLENDLEVEL $KSELECTVDGETMASKANDVALUE
          $KSELECTVDGETPLLFILTERTYPE $KSELECTVDSETPLLFILTERTYPE
          $KSELECTVDGETCLUTINUSE $KSELECTVDCLEARCLIPRGN $KSELECTVDSETCLIPRGN
          $KSELECTVDGETCLIPSTATE $KSELECTVDSETCLIPSTATE
          $KSELECTVDGETINPUTCOLORSPACEMODE $KSELECTVDSETINPUTCOLORSPACEMODE
          $KSELECTVDSETDIGITIZERUSERINTERRUPT $KSELECTVDGETKEYCOLORRANGE
          $KSELECTVDSETKEYCOLORRANGE $KSELECTVDGETNEXTKEYCOLOR
          $KSELECTVDADDKEYCOLOR $KSELECTVDGETKEYCOLOR $KSELECTVDSETKEYCOLOR
          $KSELECTVDGETCURRENTFLAGS $KSELECTVDGETDIGITIZERINFO
          $KSELECTVDGETMAXAUXBUFFER $KSELECTVDGRABONEFRAME
          $KSELECTVDGETSATURATION $KSELECTVDGETSHARPNESS $KSELECTVDGETHUE
          $KSELECTVDGETCONTRAST $KSELECTVDSETSATURATION $KSELECTVDSETSHARPNESS
          $KSELECTVDSETHUE $KSELECTVDSETCONTRAST $KSELECTVDGETBRIGHTNESS
          $KSELECTVDSETBRIGHTNESS $KSELECTVDGETINPUTGAMMAVALUE
          $KSELECTVDSETINPUTGAMMAVALUE $KSELECTVDUSETHISCLUT
          $KSELECTVDGETPLAYTHRUDESTINATION $KSELECTVDGETMASKPIXMAP
          $KSELECTVDGETVBLANKRECT $KSELECTVDGETDIGITIZERRECT
          $KSELECTVDSETDIGITIZERRECT $KSELECTVDGETACTIVESRCRECT
          $KSELECTVDGETMAXSRCRECT $DIGIOUTDOESASYNCGRABS $DIGIOUTDOESKEYCOLOR
          $DIGIOUTDOESILUT $DIGIOUTDOESHWPLAYTHRU $DIGIOUTDOESHW_DMA
          $DIGIOUTDOESWARP $DIGIOUTDOESBLEND $DIGIOUTDOESSKEW
          $DIGIOUTDOESVERTFLIP $DIGIOUTDOESHORIZFLIP $DIGIOUTDOESROTATE
          $DIGIOUTDOESSIXTEENTH $DIGIOUTDOESQUARTER $DIGIOUTDOESQUAD
          $DIGIOUTDOESDOUBLE $DIGIOUTDOESMASK $DIGIOUTDOESSHRINK
          $DIGIOUTDOESSTRETCH $DIGIOUTDOESDITHER $DIGIOUTDOES32 $DIGIOUTDOES16
          $DIGIOUTDOES8 $DIGIOUTDOES4 $DIGIOUTDOES2 $DIGIOUTDOES1
          $DIGIINSIGNALLOCK $DIGIINDOESBW $DIGIINDOESCOLOR $DIGIINVTR_BROADCAST
          $DIGIINDOESCOMPONENT $DIGIINDOESSVIDEO $DIGIINDOESCOMPOSITE
          $DIGIINDOESGENLOCK $DIGIINDOESSECAM $DIGIINDOESPAL $DIGIINDOESNTSC
          $BADCALLORDER $NODMA $BADDEPTH $NOTEXACTSIZE $NOMOREKEYCOLORS
          $NOTEXACTMATRIX $MATRIXERR $QTPARAMERR $DIGIUNIMPERR $VDTYPEKEY
          $VDTYPEMASK $VDTYPEALPHA $VDTYPEBASIC $VDUSEEVENFIELD $VDUSEODDFIELD
          $VDUSEANYFIELD $VDVTRMODE $VDBROADCASTMODE $VDDIGITIZERRGB
          $VDDIGITIZERBW $VDPLAYTHRUON $VDPLAYTHRUOFF $RGBCOMPONENTIN $SVIDEOIN
          $COMPOSITEIN $SECAMIN $PALIN $NTSCIN $VDIGINTERFACEREV
          $VIDEODIGITIZERCOMPONENTTYPE $KCLOCKSETTIMEBASESELECT
          $KCLOCKTIMECHANGEDSELECT $KCLOCKRATECHANGEDSELECT
          $KCLOCKCANCELCALLBACKSELECT $KCLOCKCALLMEWHENSELECT
          $KCLOCKDISPOSECALLBACKSELECT $KCLOCKNEWCALLBACKSELECT
          $KCLOCKSETCLOCKTIMESELECT $KCLOCKGETCLOCKTIMESELECT
          $KCLOCKIMPLEMENTSCALLBACKS $KCLOCKRATEISLINEAR
          $SYSTEMMICROSECONDCLOCK $SYSTEMTICKCLOCK $CLOCKCOMPONENTTYPE))
(provide-interface 'QuickTimeComponents)